// Make-Games.ru [Constructor, ]
// Ver 0.0.1

var MGEBackGroundStyleFillAll = 1;
var MGEBackGroundStyleFillX   = 2;
var MGEBackGroundStyleFillY   = 3;

function MGEBackGround() {
	var Self = this;
	
	//**
	Self.Sprite = null;
	Self.Position = [0.0, 0.0];
	Self.Size = [0.0, 0.0];
	Self.Velocity = [0.0, 0.0];
	//** Draw Count
	Self.DrawCount = [0, 0];
	//**
	Self.Renderer = null;
	//**
	Self.StepPosition = [0.0, 0.0];
	
	//**
	Self.Initialize = function (_mge_sprite, _mge_renderer, _mge_screen_size, _mge_preload_count, _mge_position, _mge_draw_size, _mge_style) {
		var _img;
		Self.Renderer = _mge_renderer;
		Self.Sprite = _mge_sprite;
		Self.DrawCount[0] = _mge_preload_count[0];
		Self.DrawCount[1] = _mge_preload_count[1];
		Self.Size[0] = _mge_draw_size[0];
		Self.Size[1] = _mge_draw_size[1];
		if (_mge_style === MGEBackGroundStyleFillAll) {
			if ((_mge_screen_size[0] > Self.Size[0]) || (_mge_screen_size[1] > Self.Size[1])) {
				Self.DrawCount[0] += Math.round((_mge_screen_size[0] / Self.Size[0]) + 0.5);
				Self.DrawCount[1] += Math.round((_mge_screen_size[1] / Self.Size[1]) + 0.5);
			} else {
				Self.DrawCount[0] += 1;
				Self.DrawCount[1] += 1;
			}
		} else {
			if (_mge_style === MGEBackGroundStyleFillX) {
				Self.DrawCount[0] += Math.round((_mge_screen_size[0] / Self.Size[0]) + 0.5);
			} else {
				if (_mge_style === MGEBackGroundStyleFillY) {
					Self.DrawCount[1] += Math.round((_mge_screen_size[1] / Self.Size[1]) + 0.5);
				}
			}
		}
		Self.Position[0] = _mge_position[0];
		Self.Position[1] = _mge_position[1];
	}
	
	Self._TestPosition = function () {
		if (Self.Velocity[0] > Self.Size[0]) {
			Self.Velocity[0] -= Self.Size[0];
		}
		if (Self.Velocity[1] > Self.Size[1]) {
			Self.Velocity[1] -= Self.Size[1];
		}
		if (Self.Velocity[0] < -Self.Size[0]) {
			Self.Velocity[0] += Self.Size[0];
		}
		if (Self.Velocity[1] < -Self.Size[1]) {
			Self.Velocity[1] += Self.Size[1];
		}
		if (Self.StepPosition[0] < 0) {
			if (Self.StepPosition[0] <= -Self.Size[0]) {
				Self.StepPosition[0] = Self.StepPosition[0] + Self.Size[0];
				return true;
			}
		} else {
			if (Self.StepPosition[0] >= 0) {
				Self.StepPosition[0] = Self.StepPosition[0] - Self.Size[0];
				return true;
			}
		}
		//
		if (Self.StepPosition[1] < 0) {
			if (Self.StepPosition[1] <= -Self.Size[1]) {
				Self.StepPosition[1] = Self.StepPosition[1] + Self.Size[1];
				return true;
			}
		} else {
			if (Self.StepPosition[1] >= 0) {
				Self.StepPosition[1] = Self.StepPosition[1] - Self.Size[1];
				return true;
			}
		}
		return false;
	}
	
	//**
	Self.SetPosition = function (_mge_vector) {
		Self.StepPosition[0] = Self._mge_vector[0];
		Self.StepPosition[1] = Self._mge_vector[1];
		Self._TestPosition();
	}
	
	Self.AddToPosition = function (_mge_vector) {
		Self.StepPosition[0] += Self._mge_vector[0];
		Self.StepPosition[1] += Self._mge_vector[1];
		Self._TestPosition();
	}
	
	Self.Step = function () {
		Self.StepPosition[0] += Self.Velocity[0];
		Self.StepPosition[1] += Self.Velocity[1];
		Self._TestPosition();
	}
	
	Self.Draw = function () {
		for ( var i = Self.DrawCount[0]; i >= 0; i--) {
			for ( var c = Self.DrawCount[1]; c >= 0; c--) {
				//alert( Self.Size[0] * i + " : " + Self.Size[1] * c);
				Self.Renderer.DrawSpriteRect(Self.Sprite.Image, Self.Sprite.SourcesPosition[0], Self.Sprite.SourcesPosition[1], Self.Sprite.SourcesSize[0], Self.Sprite.SourcesSize[1], 
					Self.Position[0] + (Self.Size[0] * i) + Self.StepPosition[0], 
					Self.Position[1] + (Self.Size[1] * c) + Self.StepPosition[1], Self.Size[0], Self.Size[1]);
					
			}
		}
	}
	
	//**
	Self.Clear = function () {
		Self.Sprite = null;
		Self.Position[0] = 0.0;
		Self.Position[1] = 0.0;
		Self.Size[0] = 0.0;
		Self.Size[1] = 0.0;
		Self.Velocity[0] = 0.0;
		Self.Velocity[1] = 0.0;
		//** Draw Count
		Self.DrawCount[0] = 0.0;
		Self.DrawCount[1] = 0.0;
		//**
		Self.Renderer = null;
		//**
		Self.StepPosition[0] = 0.0;
		Self.StepPosition[1] = 0.0;
	}
	
	Self.Free = function () {
		Self.Sprite = null;
		Self.Position = null;
		Self.Size = null;
		Self.Velocity = null;
		Self.DrawCount = null;
		Self.Renderer = null;
		Self.StepPosition = null;
	}
}























