// Make-Games.ru [Constructor, Конструктор]
// Ver 0.0.1

var CurRenderer = null;

function MGECanvasRenderer() {
	var Self = this;
	
	Self.Canvas = null;
	Self.Context = null;
	Self.Size = [0, 0];
	Self.Position = [0, 0];
	Self.Translated = [0.0, 0.0];
	Self.DesignSize = [0, 0];
	Self.StandartScale = [0.0, 0.0];
	
	//**
	Self.DrawSpriteCount = 0;
	Self.DrawPrimitivesCount = 0;
	
	//**
	Self.Initialize = function (_mge_canvas_object, _mge_design_size, _mge_draw_size) {
		Self.Canvas = _mge_canvas_object;
		Self.Context = Self.Canvas.getContext('2d');
		Self.Context.fillStyle = "rgba(255, 255, 255, 1)";
		Self.Context.strokeStyle = "rgba(0, 0, 0, 1)";
		
		Self.Context.fillStyle = "rgb(255, 255, 255)";
		Self.Context.strokeStyle = "rgb(255, 255, 255)";
		
		Self.DesignSize[0] = _mge_design_size[0];
		Self.DesignSize[1] = _mge_design_size[1];
		
		if (_mge_draw_size[0] !== -1) { Self.Canvas.width = _mge_draw_size[0]; }
		if (_mge_draw_size[1] !== -1) { Self.Canvas.height = _mge_draw_size[1]; }
		
		Self.Size[0] = Self.Canvas.width;
		Self.Size[1] = Self.Canvas.height;
		
		Self.Position[0] = -_mge_canvas_object.offsetLeft;
		Self.Position[1] = -_mge_canvas_object.offsetTop;
		
		Self.StandartScale[0] = Self.Size[0] / _mge_design_size[0];
		Self.StandartScale[1] = Self.Size[1] / _mge_design_size[1];

		Self.Context.scale(Self.StandartScale[0], Self.StandartScale[1]);
	}

	//**
	Self.SetFillColorRGB = function (_mge_r, _mge_g, _mge_b) {
		Self.Context.fillStyle = "rgb("+_mge_r+","+_mge_g+","+_mge_b+")";
	}
	
	Self.SetFillColorRGBV = function (_mge_color) {
		Self.Context.fillStyle = "rgb("+_mge_color[0]+","+_mge_color[1]+","+_mge_color[2]+")";
	}

	Self.SetFillColorRGBA = function (_mge_r, _mge_g, _mge_b, _mge_a) {
		Self.Context.fillStyle = "rgba("+_mge_r+","+_mge_g+","+_mge_b+","+_mge_a+")";
	}
	
	Self.SetFillColorRGBAV = function (_mge_color) {
		Self.Context.fillStyle = "rgba("+_mge_color[0]+","+_mge_color[1]+","+_mge_color[2]+","+_mge_color[3]+")";
	}
	
	Self.SetFillColorStr = function (_mge_string) {
		Self.Context.fillStyle = _mge_string;
	}
	
	//**
	Self.FillAll = function () {
		Self.Context.translate(-Self.Translated[0], -Self.Translated[1]);
		Self.Context.fillRect(0, 0, Self.Size[0], Self.Size[1]);
		Self.Context.translate(Self.Translated[0], Self.Translated[1]);
	}

	Self.FillRect = function (_mge_x, _mge_y, _mge_w, _mge_h) {
		Self.Context.fillRect(_mge_x, _mge_y, _mge_w, _mge_h);
	}

	Self.FillRectV = function (_mge_pos, _mge_size) {
		Self.Context.fillRect(_mge_pos[0], _mge_pos[1], _mge_size[0], _mge_size[1]);
	}

	Self.ClearAll = function () {
		Self.Context.translate(-Self.Translated[0], -Self.Translated[1]);
		Self.Context.clearRect(0, 0, Self.Size[0], Self.Size[1]);
		Self.Context.translate(Self.Translated[0], Self.Translated[1]);
	}

	Self.ClearRect = function (_mge_x, _mge_y, _mge_w, _mge_h) {
		Self.Context.clearRect(_mge_x, _mge_y, _mge_w, _mge_h);
	}

	Self.ClearRectV = function (_mge_pos, _mge_size) {
		Self.Context.clearRect(_mge_pos[0], _mge_pos[1], _mge_size[0], _mge_size[1]);
	}

	//**
	Self.DrawSprite = function (_mge_sprite, _mge_x, _mge_y) {
		Self.DrawSpriteCount += 1;
		Self.Context.drawImage(_mge_sprite, _mge_x, _mge_y);
	}

	Self.DrawSpriteV = function (_mge_sprite, _mge_pos) {
		Self.DrawSpriteCount += 1;
		Self.Context.drawImage(_mge_sprite, _mge_pos[0], _mge_pos[1]);
	}

	Self.DrawSpriteStretch = function (_mge_sprite, _mge_x, _mge_y, _mge_w, _mge_h) {
		Self.DrawSpriteCount += 1;
		Self.Context.drawImage(_mge_sprite, _mge_x, _mge_y, _mge_w, _mge_h);
	}

	Self.DrawSpriteStretchV = function (_mge_sprite, _mge_pos, _mge_size) {
		Self.DrawSpriteCount += 1;
		Self.DrawSpriteStretch(_mge_sprite, _mge_pos[0], _mge_pos[1], _mge_size[0], _mge_size[1]);
	}

	Self.DrawSpriteRect = function (_mge_sprite, _mge_sx, _mge_sy, _mge_sw, _mge_sh, _mge_dx, _mge_dy, _mge_dw, _mge_dh) {
		Self.DrawSpriteCount += 1;
		Self.Context.drawImage(_mge_sprite, _mge_sx, _mge_sy, _mge_sw, _mge_sh, _mge_dx, _mge_dy, _mge_dw, _mge_dh);
	}
 
 	Self.DrawSpriteRectV = function (_mge_sprite, _mge_sources_pos, _mge_sources_size, _mge_dest_pos, _mge_dest_size) {
		Self.DrawSpriteCount += 1;
		Self.DrawSpriteRect(_mge_sprite, _mge_sources_pos[0], _mge_sources_pos[1], _mge_sources_size[0], _mge_sources_size[1], _mge_dest_pos[0], _mge_dest_pos[1], _mge_dest_size[0], _mge_dest_size[1]);
	}
	
	Self.DrawSpriteEx = function (_mge_sprite, _mge_sources_pos, _mge_sources_size, _mge_dest_pos, _mge_dest_size, _mge_center, _mge_angle) {
		Self.DrawSpriteCount += 1;
		if (_mge_angle !== 0) {
			Self.Context.setTransform(Self.StandartScale[0], 0, 0, Self.StandartScale[1], _mge_dest_pos[0], _mge_dest_pos[1]);
			Self.Rotate(_mge_angle);
			Self.Context.drawImage(_mge_sprite, _mge_sources_pos[0], _mge_sources_pos[1], _mge_sources_size[0], _mge_sources_size[1], _mge_center[0], _mge_center[1], _mge_dest_size[0], _mge_dest_size[1]);
			Self.Rotate(-_mge_angle);
			Self.Context.setTransform(Self.StandartScale[0], 0, 0, Self.StandartScale[1], 0, 0);
		} else {
			Self.Context.drawImage(_mge_sprite, _mge_sources_pos[0], _mge_sources_pos[1], _mge_sources_size[0], _mge_sources_size[1], _mge_dest_pos[0], _mge_dest_pos[1], _mge_dest_size[0], _mge_dest_size[1]);
		}
	}
	
	//**
	Self.DrawCollisionMask = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		switch (_mge_collision_type) {
			case COLL_AABB: {
				Self.BeginPath();
					Self.Box(_mge_vec1, _mge_vec2);
				Self.EndPath();
				Self.Stroke();
				return;
			}
			case COLL_BOX: {
				Self.BeginPath();
					Self.Box(_mge_vec1, _mge_vec2);
				Self.EndPath();
				Self.Stroke();
				return;
			}
			case COLL_POINT: {
				Self.BeginPath();
					Self.Point(_mge_vec1, [0.5, 0.5]);
				Self.EndPath();
				Self.Stroke();
				return;
			}
			case COLL_LINE: {
				Self.BeginPath();
					Self.Line(_mge_vec1, _mge_vec2);
				Self.EndPath();
				Self.Stroke();
				return;
			}
			case COLL_SPHERE: {
				Self.BeginPath();
					Self.Sphere(_mge_vec1, _mge_vec2[0]);
				Self.EndPath();
				Self.Stroke();
				return;
			}
			case COLL_TRIANGLE: {
				Self.BeginPath();
					Self.Triangle(_mge_vec1, _mge_vec2, _mge_vec3);
				Self.EndPath();
				Self.Stroke();
				return;
			}
			case COLL_TETRAGON: {
				Self.BeginPath();
					Self.Tetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
				Self.EndPath();
				Self.Stroke();
				return;
			}
		}
	}
	
	//**
	Self.SetFontStyle = function (_mge_font_size, _mge_font_family) {
		Self.Context.font = _mge_font_size + "pt " + _mge_font_family;
	}
	
	Self.SetFontStyleStr = function (_mge_string) {
		Self.Context.font = _mge_string;
	}
	
	Self.DrawText = function (_mge_string, _mge_x, _mge_y) {
		Self.Context.fillText(_mge_string, _mge_x, _mge_y);
	}
	
	Self.DrawTextV = function (_mge_string, _mge_position) {
		Self.Context.DrawText(_mge_string, _mge_position[0], _mge_position[1]);
	}
	
	//**
	Self.Translate = function (_mge_x, _mge_y) {
		Self.Context.translate(_mge_x, _mge_y);
		Self.Translated[0] = _mge_x;
		Self.Translated[1] = _mge_y;
	}
	
	Self.TranslateV = function (_mge_vector) {
		Self.Context.translate(_mge_vector[0], _mge_vector[1]);
		Self.Translated[0] = _mge_vector[0];
		Self.Translated[1] = _mge_vector[1];
	}
	
	Self.Rotate = function (_mge_angle) {
		Self.Context.rotate(_mge_angle);
	}
	
	Self.Scale = function (_mge_x, _mge_y) {
		Self.Context.scale(_mge_x, _mge_y);
	}
	
	Self.ScaleV = function (_mge_vector) {
		Self.Context.scale(_mge_vector[0], _mge_vector[1]);
	}
	
	//**
	Self.SetAlpha = function (_mge_alpha) {
		Self.Context.globalAlpha = _mge_alpha;
	}
	
	Self.GetAlpha = function () {
		return Self.Context.globalAlpha;
	}
	
	//**
	Self.SetLineWidth = function (_mge_line_width) {
		Self.Context.lineWidth = _mge_line_width;
	}
	
	Self.GetLineWidth = function () {
		return Self.Context.lineWidth;
	}
	
	//**
	Self.SetLineColorRGB = function (_mge_r, _mge_g, _mge_b) {
		Self.Context.strokeStyle = "rgb("+_mge_r+","+_mge_g+","+_mge_b+")";
	}
	
	Self.SetLineColorRGBV = function (_mge_color) {
		Self.Context.strokeStyle = "rgb("+_mge_color[0]+","+_mge_color[1]+","+_mge_color[2]+")";
	}
	
	Self.SetLineColorRGBA = function (_mge_r, _mge_g, _mge_b, _mge_a) {
		Self.Context.strokeStyle = "rgba("+_mge_r+","+_mge_g+","+_mge_b+","+_mge_a+")";
	}
	
	Self.SetLineColorRGBAV = function (_mge_color) {
		Self.Context.strokeStyle = "rgba("+_mge_color[0]+","+_mge_color[1]+","+_mge_color[2]+","+_mge_color[3]+")";
	}
	
	Self.SetLineColorStr = function (_mge_string) {
		Self.Context.strokeStyle = _mge_string;
	}
	
	//**
	Self.BeginPath = function () {
		Self.Context.beginPath();
	}
	
	Self.EndPath = function () {
		Self.Context.closePath();
	}
	
	Self.Fill = function () {
		Self.Context.fill();
	}
	
	Self.Stroke = function () {
		Self.Context.stroke();
	}
	
	//**
	Self.MoveTo = function (_mge_x, _mge_y) {
		Self.Context.moveTo(_mge_x, _mge_y);
	}
	
	Self.MoveToV = function (_mge_vector) {
		Self.Context.moveTo(_mge_vector[0], _mge_vector[1]);
	}
	
	//**
	Self.LineTo = function (_mge_x, _mge_y) {
		Self.Context.lineTo(_mge_x, _mge_y);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	Self.LineToV = function (_mge_vector) {
		Self.Context.lineTo(_mge_vector[0], _mge_vector[1]);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	//** Primitives
	Self.Point = function (_mge_center, _mge_size) {
		Self.FillRect(_mge_center[0] - _mge_size[0], _mge_center[1] - _mge_size[1], _mge_size[0]+ _mge_size[0], _mge_size[1]+ _mge_size[1]);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	Self.Box = function (_mge_vector1, _mge_vector2) {
		Self.MoveToV(_mge_vector1);
		Self.LineTo(_mge_vector2[0], _mge_vector1[1]);
		Self.LineToV(_mge_vector2);
		Self.LineTo(_mge_vector1[0], _mge_vector2[1]);
		Self.LineToV(_mge_vector1);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	Self.Tetragon = function (_mge_vector1, _mge_vector2, _mge_vector3, _mge_vector4) {
		Self.MoveToV(_mge_vector1);
		Self.LineToV(_mge_vector2);
		Self.LineToV(_mge_vector3);
		Self.LineToV(_mge_vector4);
		Self.LineToV(_mge_vector1);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	Self.Triangle = function (_mge_vector1, _mge_vector2, _mge_vector3) {
		Self.MoveToV(_mge_vector1);
		Self.LineToV(_mge_vector2);
		Self.LineToV(_mge_vector3);
		Self.LineToV(_mge_vector1);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	Self.Line = function (_mge_vector1, _mge_vector2) {
		Self.MoveToV(_mge_vector1);
		Self.LineToV(_mge_vector2);
		Self.LineToV(_mge_vector1);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	Self.Sphere = function (_mge_center, _mge_radius) {
		Self.Context.arc(_mge_center[0], _mge_center[1], _mge_radius, 0, 2 * PI, false);
		Self.DrawPrimitivesCount += Self.DrawPrimitivesCount;
	}
	
	//**
	Self.BeginDraw = function () {
		Self.DrawSpriteCount = 0;
		Self.DrawPrimitivesCount = 0;
		Self.Context.setTransform(Self.StandartScale[0], 0, 0, Self.StandartScale[1], 0, 0);
	}
	
	Self.EndDraw = function () {
		Self.DrawSpriteCount = 0;
		Self.DrawPrimitivesCount = 0;
	}
	
	//**
	Self.Clear = function () {
		Self.Canvas = null;
		Self.Context = null;
		Self.Size[0] = 0;
		Self.Size[1] = 0;
		Self.Position[0] = 0;
		Self.Position[1] = 0;
		Self.Translated[0] = 0.0;
		Self.Translated[1] = 0.0;
		Self.DesignSize[0] = 0;
		Self.DesignSize[1] = 0;
		Self.StandartScale[0] = 1.0;
		Self.StandartScale[1] = 1.0;
		Self.DrawSpriteExCount = 0;
	}
	
	//**
	Self.Free = function () {
		Self.Size = null;
		Self.Translated = null;
		Self.DesignSize = null;
		Self.StandartScale = null;
		Self.Position = null;
	}
}

function CanvasAdd (_mge_canvas_width, _mge_canvas_height) {
	var _mge_canvas_object = document.createElement('canvas');
	_mge_canvas_object.width = _mge_canvas_width;
	_mge_canvas_object.height = _mge_canvas_height;
	return _mge_canvas_object;
}



















 