// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGEFontEncode() {
	var Self = this;
	
	//**
	Self.EncodeCount = 0;
	Self.EncodeCharCode = [];
	Self.Encode_X = [];
	Self.Encode_Y = [];
	
	//**
	Self.AddCharCode = function (_mge_char_code, _mge_position) {
		Self.EncodeCharCode[Self.EncodeCount] = _mge_char_code;
		Self.Encode_X[Self.EncodeCount] = _mge_position[0];
		Self.Encode_Y[Self.EncodeCount] = _mge_position[1];
		Self.EncodeCount += 1;
	}
	
	Self.DelCharCode = function (_mge_char_code) {
		for ( var i = Self.EncodeCount - 1; i >= 0; i--) {
			if (Self.EncodeCharCode[i] === _mge_char_code) {
				Self.EncodeCount -= 1;
				if (i !== Self.EncodeCount) {
					Self.EncodeCharCode[i] = Self.EncodeCharCode[Self.EncodeCount];
					Self.Encode_X[i] = Self.Encode_X[Self.EncodeCount];
					Self.Encode_Y[i] = Self.Encode_Y[Self.EncodeCount];
				}
			}
		}
	}
	
	Self.DelPosition = function (_mge_position) {
		for ( var i = Self.EncodeCount - 1; i >= 0; i--) {
			if ((Self.Encode_X[i] === _mge_position[0]) && (Self.Encode_Y[i] === _mge_position[1])) {
				Self.EncodeCount -= 1;
				if (i !== Self.EncodeCount) {
					Self.EncodeCharCode[i] = Self.EncodeCharCode[Self.EncodeCount];
					Self.Encode_X[i] = Self.Encode_X[Self.EncodeCount];
					Self.Encode_Y[i] = Self.Encode_Y[Self.EncodeCount];
				}
			}
		}
	}
	
	Self.FindChar = function (_mge_char_code) {
		//alert(Self.EncodeCount);
		for ( var i = Self.EncodeCount - 1; i >= 0; i--) {
			//alert(Self.EncodeCharCode[i]);
			//alert(_mge_char_code);
			if (Self.EncodeCharCode[i] === _mge_char_code) {
				//alert("FIND")
				return i;
			}
		}
		return -1;
	}
	
	//**
	Self.Draw = function (_mge_string, _mge_font, _mge_position) {
		var _len = _mge_string.length;
		var _id;
		for ( var i = 0; i < _len; i++) {
			_id = Self.FindChar( _mge_string.charCodeAt(i) );
			if (_id !== -1) {
				_mge_font.DrawFromIndex(_mge_position, Self.Encode_X[_id], Self.Encode_Y[_id]);
				_mge_position[0] += _mge_font.CharSize[0] + _mge_font.CharFreeSize[0];
			}
		}
	}
	
	Self.GetArray = function (_mge_string, _mge_array) {
		var _len = _mge_string.length;
		var _id, _arr_pos;
		_mge_array.length = _len * 2;
		_arr_pos = 0;
		for ( var i = 0; i < _len; i++) {
			_id = Self.FindChar( _mge_string.charCodeAt(i) );
			//alert(_mge_string.charCodeAt(i));
			//alert(_id);
			if (_id !== -1) {
				//alert(Self.Encode_X[_id] + " : " + Self.Encode_Y[_id]);
				_mge_array[_arr_pos] = Self.Encode_X[_id];
				_arr_pos += 1;
				_mge_array[_arr_pos] = Self.Encode_Y[_id];
				_arr_pos += 1;
			}
		}
	}
	
	//**
	Self.Clear = function () {
		Self.EncodeCount = 0;
		//+USE_NEW_ARRAY+//Self.EncodeCharCode = [];
		//+USE_LENGTH+//Self.EncodeCharCode.length = 0;
		//+USE_NEW_ARRAY+//Self.Encode_X = [];
		//+USE_LENGTH+//Self.Encode_X.length = 0;
		//+USE_NEW_ARRAY+//Self.Encode_Y = [];
		//+USE_LENGTH+//Self.Encode_Y.length = 0;
	}
	
	//**
	Self.Free = function () {
		Self.EncodeCharCode = null;
		Self.Encode_X = null;
		Self.Encode_Y = null;
	}
	
}

function MGEFont() {
	var Self = this;
	
	//**
	Self.Sprite = null;
	
	//**
	Self.CharSize = [0.0, 0.0];
	Self.CharFreeSize = [0.0, 0.0];
	
	//**
	Self.Renderer = null;
	
	//**
	Self.Initialize = function (_mge_sprite, _mge_char_size, _mge_renderer) {
		Self.Sprite = _mge_sprite;
		Self.CharSize[0] = _mge_char_size[0];
		Self.CharSize[1] = _mge_char_size[1];
		Self.CharFreeSize[0] = 0.0;
		Self.CharFreeSize[1] = 0.0;
		Self.Renderer = _mge_renderer;
	}
	
	//**
	Self.DrawFromIndex = function (_mge_position, _mge_id_x, _mge_id_y) {	
		Self.Renderer.DrawSpriteRect(Self.Sprite.Image, Self.CharSize[0] * _mge_id_x, Self.CharSize[1] * _mge_id_y, Self.CharSize[0], Self.CharSize[1], _mge_position[0], _mge_position[1], Self.CharSize[0], Self.CharSize[1]);
	}
	
	//** id [x, y, x, y ...]
	Self.DrawFromArray = function (_mge_position, _mge_id_aray) {
		var _pos_x = _mge_position[0];
		var _pos_y = _mge_position[1];
		var _img_pos_x, _img_pos_y;
		var _len = Math.round(_mge_id_aray.length / 2);
		for ( var i = 0; i < _len; i++) {
			if (_mge_id_aray[i * 2] === -1) {
				_pos_y += Self.CharSize[1] + Self.CharFreeSize[1];
				_pos_x = _mge_position[0] + Self.CharFreeSize[0];
			} else {
				_img_pos_x = Self.CharSize[0] * _mge_id_aray[i * 2];
				_img_pos_y = Self.CharSize[1] * _mge_id_aray[i * 2 + 1];
				
				Self.Renderer.DrawSpriteRect(Self.Sprite.Image, _img_pos_x, _img_pos_y, Self.CharSize[0], Self.CharSize[1], 
					_pos_x, _pos_y, Self.CharSize[0], Self.CharSize[1]);
				
				_pos_x += Self.CharSize[0] + Self.CharFreeSize[0];
			}
		}
	}
	
	//**
	Self.Clear = function () {
		Self.Sprite = null;
		//**
		Self.CharSize[0] = 0.0;
		Self.CharSize[1] = 0.0;
		Self.CharFreeSize[0] = 0.0;
		Self.CharFreeSize[1] = 0.0;
		//**
		Self.Renderer = null;
	}
	
	//**
	Self.Free = function () {
		Self.Sprite = null;
		Self.CharSize = null;
		Self.CharFreeSize = null;
		Self.Renderer = null;
	}
	
}


























