// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGEInput() {
	var Self = this;

	//** use touch event / mouse event
	Self.UseTouchEvents = false;

	//** keys pressed
	Self.KeysPressed = new Array(256);
	for (var i = 0; i <= 255; i++) { Self.KeysPressed[i] = false; };

	//** mouse / touch
	Self.MouseClick = false;
	Self.MouseDown = false;
	Self.MousePos = [0, 0];
	Self.StandartScale = [1.0, 1.0];
	Self.AddToMousePosition = [0, 0];

	//** user functions
	Self.ProcKeyDown = function () {  }
	Self.ProcKeyUp = function () {  }
	Self.ProcTouchStart = function () {  }
	Self.ProcTouchMove = function () {  }
	Self.ProcTouchEnd = function () {  }
	Self.ProcMouseMove = function () {  }
	Self.ProcMouseDown = function () {  }
	Self.ProcMouseUp = function () {  }
		
	//**
	Self.Initialize = function (_mge_hook_object, _mge_use_touch_events, _mge_standart_scale, _mge_element_position) {
		Self.UseTouchEvents = _mge_use_touch_events;
		Self.StandartScale[0] = _mge_standart_scale[0];
		Self.StandartScale[1] = _mge_standart_scale[1];
		Self.AddToMousePosition[0] = _mge_element_position[0];
		Self.AddToMousePosition[1] = _mge_element_position[1];
		if ( _mge_hook_object.addEventListener ) {
			document.addEventListener("keydown", Self._KeyDownListener, false);
			document.addEventListener("keyup", Self._KeyUpListener, false);
			if ( Self.UseTouchEvents == true ) {
				_mge_hook_object.addEventListener("touchstart", Self._TouchStartListener, false);
				_mge_hook_object.addEventListener("touchmove", Self._TouchMoveListener, false);
				_mge_hook_object.addEventListener("touchend", Self._TouchEndListener, false);
			} else {
				_mge_hook_object.addEventListener("mousemove", Self._MouseMoveListener, false);
				_mge_hook_object.addEventListener("mousedown", Self._MouseDownListener, false);
				_mge_hook_object.addEventListener("mouseup", Self._MouseUpListener, false);
			}
		} else {
			document.attachEvent("onkeydown", Self._KeyDownListener);
			document.attachEvent("onkeyup", Self._KeyUpListener);
			if ( Self.UseTouchEvents == true ) {
				_mge_hook_object.attachEvent("ontouchstart", Self._TouchStartListener);
				_mge_hook_object.attachEvent("ontouchmove", Self._TouchMoveListener);
				_mge_hook_object.attachEvent("ontouchend", Self._TouchEndListener);
			} else {
				_mge_hook_object.attachEvent("onmousemove", Self._MouseMoveListener);
				_mge_hook_object.attachEvent("onmousedown", Self._MouseDownListener);
				_mge_hook_object.attachEvent("onmouseup", Self._MouseUpListener);
			}
		}
	}
	
	//**
	Self._TouchStartListener = function(_mge_event) {
		Self.MouseClick = true;
		Self.MouseDown = true;
		Self.MousePos[0] = _mge_event.touches[0].pageX / Self.StandartScale[0];
		Self.MousePos[1] = _mge_event.touches[0].pageY / Self.StandartScale[1];
		Self.ProcTouchStart(_mge_event);
	}

	Self._TouchMoveListener = function(_mge_event) {
		Self.MousePos[0] = Self.AddToMousePosition[0] + _mge_event.touches[0].pageX / Self.StandartScale[0];
		Self.MousePos[1] = Self.AddToMousePosition[1] + _mge_event.touches[0].pageY / Self.StandartScale[1];
		Self.ProcTouchMove(_mge_event);
	}

	Self._TouchEndListener = function(_mge_event) {
		Self.MouseDown = false;
		Self.MouseClick = true;
		Self.ProcTouchEnd(_mge_event);
	}

	Self._KeyDownListener = function(_mge_event) {
		Self.KeysPressed[_mge_event.keyCode] = true;
		Self.ProcKeyDown(_mge_event);
	}
	
	Self._KeyUpListener = function(_mge_event) {
		Self.KeysPressed[_mge_event.keyCode] = false;
		Self.ProcKeyUp(_mge_event);
	}

	Self._MouseDownListener = function(_mge_event) {
		Self.MouseDown = true;
		Self.MouseClick = true;
		Self.ProcMouseDown(_mge_event);
	}
	
	Self._MouseUpListener = function(_mge_event) {
		Self.MouseDown = false;
		Self.MouseClick = true;
		Self.ProcMouseUp(_mge_event);
	}

	Self._MouseMoveListener = function(_mge_event){
		//Self.MousePos[0] = _mge_event.pageX / Self.StandartScale[0];
		//Self.MousePos[1] = _mge_event.pageY / Self.StandartScale[1];
		Self.MousePos[0] = Self.AddToMousePosition[0] + _mge_event.clientX + (document.documentElement.scrollLeft || document.body.scrollLeft) - document.documentElement.clientLeft;
		Self.MousePos[1] = Self.AddToMousePosition[1] + _mge_event.clientY + (document.documentElement.scrollTop || document.body.scrollTop) - document.documentElement.clientTop;
		
		Self.MousePos[0] /= Self.StandartScale[0];
		Self.MousePos[1] /= Self.StandartScale[1];
		
		Self.ProcMouseMove(_mge_event);
	}
	
	//**
	Self.Clear = function () {
		Self.UseTouchEvents = false;
		for (var i = 0; i <= 255; i++) { Self.KeysPressed[i] = false; };
		Self.MouseClick = false;
		Self.MouseDown = false;
		Self.MousePos[0] = 0;
		Self.MousePos[1] = 0;
		Self.AddToMousePosition[0] = 0;
		Self.AddToMousePosition[1] = 0;
		Self.StandartScale[0] = 1.0;
		Self.StandartScale[0] = 1.0;
		Self.ProcKeyDown = function() {  }
		Self.ProcKeyUp = function() {  }
		Self.ProcTouchStart = function() {  }
		Self.ProcTouchMove = function() {  }
		Self.ProcTouchEnd = function() {  }
		Self.ProcMouseMove = function() {  }
		Self.ProcMouseDown = function() {  }
		Self.ProcMouseUp = function() {  }
	}
 
	//**
	Self.Free = function () {
		Self.KeysPressed = null;
		Self.MousePos = null;
		Self.StandartScale = null;
	}
}







 











 