// Make-Games.ru [Constructor, ]
// Ver 0.0.1
// vector;

var RAD2DEG = (180 / Math.PI);
var DEG2RAD = (Math.PI / 180);
var DEG2RAD90 = (90 * DEG2RAD);
var DEG2RAD360 = (360 * DEG2RAD);
var EPS = 2.2204460492503130808472633361816E-16;
var PI = Math.PI + 0.0;

var COLL_NONE = 0;
var COLL_AABB = 1;
var COLL_BOX = 2;
var COLL_POINT = 3;
var COLL_LINE = 4;
var COLL_SPHERE = 5;
var COLL_TRIANGLE = 6;
var COLL_TETRAGON = 7;

var Math2D = null;

function MGEMath2D() {
	var Self = this;
	
	Self._mge_enter = 0;
	Self._mge_pexit = 0;
	
	//**
	Self._SQR = function (_mge_num) {
		return _mge_num * _mge_num;
	}
	
	Self._LineMagnitude = function (_mge_x1, _mge_y1, _mge_x2, _mge_y2) {
		return Self._SQR(_mge_x2 - _mge_x1) + Self._SQR(_mge_y2 - _mge_y1);
	}

	Self._LineMagnitude2 = function (_mge_vec1, _mge_vec2) {
		return Self._SQR(_mge_vec2[0] - _mge_vec1[0]) + Self._SQR(_mge_vec2[1] - _mge_vec1[1]);
	}
	
	Self._Line_AABB_1d = function (_mge_start, _mge_dir, _mge_min, _mge_max) {
		var _ooDir, _t0, _t1;
		var _result = false;
		if (Math.abs(_mge_dir) < EPS) { _result = (_mge_start >= _mge_min) && (_mge_start <= _mge_max); }
		_ooDir = 1.0 / _mge_dir;
		_t0 = (_mge_min - _mge_start) * _ooDir;
		_t1 = (_mge_max - _mge_start) * _ooDir;
		if (_t0 > _t1) { Self.Replace(_t0, _t1); }
		if ((_t0 > Self._mge_pexit) || (_t1 < Self._mge_enter)) { return _result; }
		if (_t0 > Self._mge_enter) { Self._mge_enter = _t0; }
		if (_t1 < Self._mge_pexit) { Self._mge_pexit = _t1; }
		return true;
	}
	
	Self._LinevsTriangleLines = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5) {
		if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
			else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec4, _mge_vec5) == true) { return true; }
				else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec5, _mge_vec3) == true) { return true; }
					else { return false; }
	}
	
	Self._LinevsTetragonLines = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
			else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec4, _mge_vec5) == true) { return true; }
				else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec5, _mge_vec6) == true) { return true; }
					else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec6, _mge_vec3) == true) { return true; }
						else { return false; }
	}
	
	//**
	Self.RandomF = function (_mge_max) {
		return Math.random() * _mge_max;
	}
	
	Self.RandomI = function (_mge_max) {
		return Math.round(Math.random() * _mge_max);
	}
	
	Self.RandomFEx = function (_mge_min, _mge_min) {
		return (Math.random() * (_mge_max - _mge_min)) + _mge_min;
	}
	
	Self.RandomIEx = function (_mge_min, _mge_max) {
		return Math.round( (Math.random() * (_mge_max - _mge_min)) + _mge_min );
	}

	//** Convert
	
	Self.DegToRad = function (_mge_num) {
		return _mge_num * DEG2RAD;
	}
	
	Self.RadToDeg = function (_mge_num) {
		return _mge_num * RAD2DEG;
	}
	
	Self.Replace = function (_mge_num1, _mge_num2) {
		var _tmp = _mge_num1;
		_mge_num1 = _mge_num2;
		_mge_num2 = _tmp;
	}
	
	Self.SetTriangleCCW = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		if ((_mge_vec1[0] - _mge_vec2[0]) * (_mge_vec3[1] - _mge_vec2[1]) > (_mge_vec1[1] - _mge_vec2[1]) * (_mge_vec3[0] - _mge_vec2[0])) {
			Vec.Replace2(_mge_vec2, _mge_vec3);
		}
	}
	
	Self.SetTetragonCCW = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		if ((_mge_vec1[0] - _mge_vec2[0]) * (_mge_vec3[1] - _mge_vec2[1]) > (_mge_vec1[1] - _mge_vec2[1]) * (_mge_vec3[0] - _mge_vec2[0])) {
			Vec.Replace2(_mge_vec2, _mge_vec4);
		}
	}
	
	//** angle, Speed to Velosity
	Self.GetVelosity = function (_mge_vel, _mge_speed, _mge_angle) {
		_mge_vel[0] = _mge_speed * Math.sin(_mge_angle);
		_mge_vel[1] = 0 - (_mge_speed * Math.cos(_mge_angle));
	}
	
	Self.GetSpeedAngle = function (_mge_result, _mge_vel) {
		var _d;
		_mge_result[1] = Self.PointAnglePoint(IdentityVector2F, _mge_vel);
		_mge_result[0] = Math.abs(Self.PointDistPoint(_mge_vel, IdentityVector2F) * Math.cos(0));
	}
	
	//** Distance
	Self.PointDistPoint = function (_mge_point1, _mge_point2) {
		var _x, _y;
		_x = (_mge_point1[0] - _mge_point2[0]);
		_y = (_mge_point1[1] - _mge_point2[1]);
		_x = Math.sqrt((_x * _x) + (_y * _y));
		if (_x < 0) { return -_x; } else { return _x; }
	}
	
	Self.PointDistLine = function (_mge_point, _mge_lvec1, _mge_lvec2) {
		var _SqLineMag, _u, _ix, _iy, _result;
		_SqLineMag = Self._LineMagnitude2(_mge_lvec1, _mge_lvec2);
		if (_SqLineMag < EPS) {
			_result = Self.PointDistPoint(_mge_point, _mge_lvec1);
		}
		_u = ( (_mge_point[0] - _mge_lvec1[0])*(_mge_lvec2[0] - _mge_lvec1[0]) + (_mge_point[1] - _mge_lvec1[1])*(_mge_lvec2[1] - _mge_lvec1[1]) ) / _SqLineMag;
		if ((_u < EPS) || (_u > 1)) {
			_ix = Self._LineMagnitude2(_mge_point, _mge_lvec1);
			_iy = Self._LineMagnitude2(_mge_point, _mge_lvec2);
			_result = Self.Min(_ix, _iy);
		} else {
			_ix = _mge_lvec1[0] + _u * (_mge_lvec2[0] - _mge_lvec1[0]);
			_iy = _mge_lvec1[1] + _u * (_mge_lvec2[1]- _mge_lvec1[1]);
			_result = Self._LineMagnitude(_mge_point[0], _mge_point[1], _ix, _iy);
		}
		return Math.sqrt(_result);
	}
	
	//** Min / Max
	
	Self.Min = function (_mge_a, _mge_b) {
		if (_mge_a > _mge_b) { return _mge_b; } else { return _mge_a }
	}
	
	Self.Max = function (_mge_a, _mge_b) {
		if (_mge_a > _mge_b) { return _mge_a; } else { return _mge_b }
	}
	
	//** Move
	
	Self.Move = function (_mge_point, _mge_angle, _mge_speed) {
		_mge_point[0] = _mge_point[0] - (Math.cos(_mge_angle) * _mge_speed);
		_mge_point[1] = _mge_point[1] - (Math.sin(_mge_angle) * _mge_speed);
	}
	
	//** Angles
	
	Self.PointAnglePoint = function (_mge_vec1, _mge_vec2) {
		var _angle = Math.atan2(_mge_vec2[1] - _mge_vec1[1], _mge_vec2[0] - _mge_vec1[0]) + DEG2RAD90;
		if (_angle < 0) {
			_angle += DEG2RAD360;
		}
		return _angle;
	}
	
	Self.PointRotate = function (_mge_point, _mge_center, _mge_angle) {
		var _d, _a;
		_d = Self.PointDistPoint(_mge_point, _mge_center);
		_a = Self.PointAnglePoint(_mge_center, _mge_point) + _mge_angle;
		_mge_point[0] = _mge_center[0] + (_d * Math.sin(_a));
		_mge_point[1] = _mge_center[1] - (_d * Math.cos(_a));
	}
	
	Self.PointRotateA = function (_mge_point, _mge_center, _mge_angle) {
		var _d;
		_d = Self.PointDistPoint(_mge_point, _mge_center);
		_mge_point[0] = _mge_center[0] + (_d * Math.sin(_mge_angle));
		_mge_point[1] = _mge_center[1] - (_d * Math.cos(_mge_angle));
	}
	
	//** Collision AABB

	Self.AABBvsPoint = function (_mge_min, _mge_max, _mge_point) {
		if (_mge_point[0] > _mge_max[0]) return false;
		if (_mge_point[0] < _mge_min[0]) return false;
		if (_mge_point[1] > _mge_max[1]) return false;
		if (_mge_point[1] < _mge_min[1]) return false;
		return true;
	}
	
	Self.AABBvsLine = function (_mge_min, _mge_max, _mge_lvec1, _mge_lvec2) {
		var _enter, _pexit;
		var _dir = [_mge_lvec2[0], _mge_lvec2[1]];
		Self._mge_enter = 0.0;
		Self._mge_pexit = 1.0;
		Vec.Sub22(_dir, _mge_lvec1);
		if (Self._Line_AABB_1d(_mge_lvec1[0], _dir[0], _mge_min[0], _mge_max[0]) != true) { return false; }
		if (Self._Line_AABB_1d(_mge_lvec1[1], _dir[1], _mge_min[1], _mge_max[1]) != true) { return false; }
		return true;
	}
	
	Self.AABBvsAABB = function (_mge_min1, _mge_max1, _mge_min2, _mge_max2) {
		if ((_mge_min1[0] > _mge_max2[0]) || (_mge_max1[0] < _mge_min2[0]) || (_mge_min1[1] > _mge_max2[1]) || (_mge_max1[1] < _mge_min2[1])) { return false; } else { return true; }
	}
	
	Self.AABBvsSphere = function (_mge_min, _mge_max, _mge_vec, _mge_rad) {
		var _d = 0.0;
		var _d2 = 0.0;
		if (Self.AABBvsPoint(_mge_min, _mge_max, _mge_vec) == true) { return true; }
		if (_mge_vec[0] < _mge_min[0]) {
			_d2 = _mge_vec[0] - _mge_min[0];
			_d = _d2 * _d2;
		}
		if (_mge_vec[0] < _mge_max[0]) {
			_d2 = _mge_vec[0] - _mge_max[0];
			_d = _d + _d2 * _d2;
		}
		if (_mge_vec[1] < _mge_min[1]) {
			_d2 = _mge_vec[1] - _mge_min[1];
			_d = _d + _d2 * _d2;
		}
		if (_mge_vec[1] > _mge_max[1]) {
			_d2 = _mge_vec[1] - _mge_max[1];
			_d = _d + _d2 * _d2;
		}
		return _d <= (_mge_rad * _mge_rad);
	}
	
	Self.AABBvsBox = function (_mge_min, _mge_max, _mge_vec1, _mge_vec2) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		return Self.AABBvsAABB(_mge_min, _mge_max, _min, _max);
	}
	
	Self.AABBvsTriangle = function (_mge_min, _mge_max, _mge_vec3, _mge_vec4, _mge_vec5) {
		var _vec1 = [_mge_min[0], _mge_max[1]];
		var _vec2 = [_mge_max[0], _mge_min[1]];
		return Self.TetragonvsTriangle(_mge_min, _vec2, _mge_max, _vec1, _mge_vec3, _mge_vec4, _mge_vec5);
	}
	
	Self.AABBvsTetragon = function (_mge_min, _mge_max, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		var _vec1 = [_mge_min[0], _mge_max[1]];
		var _vec2 = [_mge_max[0], _mge_min[1]];
		return Self.TetragonvsTetragon(_mge_min, _vec2, _mge_max, _vec1, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6);
	}
	
	//** Collision Box
	
	Self.BoxvsPoint = function (_mge_vec1, _mge_vec2, _mge_point) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		return Self.AABBvsPoint(_min, _max, _mge_point);
	}
	
	Self.BoxvsLine = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		return Self.AABBvsLine(_min, _max, _mge_vec3, _mge_vec4);
	}
	
	Self.BoxvsBox = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		return Self.AABBvsBox(_min, _max, _mge_vec3, _mge_vec4);
	}
	
	Self.BoxvsSphere = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_rad) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		return Self.AABBvsSphere(_min, _max, _mge_vec3, _mge_rad);
	}
	
	Self.BoxvsTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		Self.AABBvsTriangle(_min, _max, _mge_vec3, _mge_vec4, _mge_vec5);
	}
	
	Self.BoxvsTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		var _min = [_mge_vec1[0], _mge_vec1[1]];
		var _max = [_mge_vec1[0], _mge_vec1[1]];
		Vec.Min2(_min, _mge_vec2);
		Vec.Max2(_max, _mge_vec2);
		Self.AABBvsTetragon(_min, _max, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6);
	}
	
	//** Collision Point
	
	Self.PointvsPoint = function (_mge_point1, _mge_point2) {
		return (_mge_point1[0] === _mge_point2[0]) && (_mge_point1[1] === _mge_point2[1]);
	}
	
	Self.PointvsSphere = function (_mge_point, _mge_vec, _mge_rad) {
		return Self._SQR(_mge_point[0] - _mge_vec[0]) + Self._SQR(_mge_point[1] - _mge_vec[1]) <= _mge_rad * _mge_rad;
	}
	
	Self.PointvsLine = function (_mge_point, _mge_lvec1, _mge_lvec2) {
		var _a = _mge_point[1] - _mge_lvec1[1];
		var _b = _mge_lvec2[1] - _mge_lvec1[1];
		var _c = _mge_point[0] - _mge_lvec1[0];
		var _d = _mge_lvec2[0] - _mge_lvec1[0];
		if (_a != 0 && _b != 0) { _a = _a / _b; } else { _a = 0; }
		if (_c != 0 && _d != 0) { _c = _c / _d; } else { _c = 0; }
		if (_a == _c) {
			return Self.BoxvsPoint(_mge_lvec1, _mge_lvec2, _mge_point);
		}
		return false;
	}
	
	Self.PointvsTriangle = function (_mge_point, _mge_vec1, _mge_vec2, _mge_vec3) {
		if ((_mge_point[0] - _mge_vec1[0]) * (_mge_vec1[1] - _mge_vec2[1]) - (_mge_point[1] - _mge_vec1[1]) * (_mge_vec1[0] - _mge_vec2[0]) >= 0) {
			if ((_mge_point[0] - _mge_vec2[0]) * (_mge_vec2[1] - _mge_vec3[1]) - (_mge_point[1] - _mge_vec2[1]) * (_mge_vec2[0] - _mge_vec3[0]) >= 0) {
				if ((_mge_point[0] - _mge_vec3[0]) * (_mge_vec3[1] - _mge_vec1[1]) - (_mge_point[1] - _mge_vec3[1]) * (_mge_vec3[0] - _mge_vec1[0]) >= 0) { return true; }}}
		return false;
	}
	
	Self.PointvsTetragon = function (_mge_point, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		return Self.PointvsTriangle(_mge_point, _mge_vec1, _mge_vec2, _mge_vec3) || Self.PointvsTriangle(_mge_point, _mge_vec3, _mge_vec4, _mge_vec1);
	}
	
	//** Collision Line
	
	Self.LinevsSphere = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_rad) {
		return Self.PointDistLine(_mge_vec3, _mge_vec1, _mge_vec2) <= _mge_rad;
	}
	
	Self.LinevsLine = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) { 
		var _d, _da, _db, _ta, _tb, _L1, _L2, _L3, _L4, _L5, _L6;
		var _point = [0.0, 0.0];
		_L1 = _mge_vec1[0] - _mge_vec2[0];
		_L2 = _mge_vec4[1] - _mge_vec3[1];
		_L3 = _mge_vec1[1] - _mge_vec2[1];
		_L4 = _mge_vec4[0] - _mge_vec3[0];
		_L5 = _mge_vec1[0] - _mge_vec3[0];
		_L6 = _mge_vec1[1] - _mge_vec3[1];
		_d  = (_L1 * _L2) - (_L3 * _L4);
		_da = (_L5 * _L2) - (_L6 * _L4);
		_db = (_L1 * _L6) - (_L3 * _L5);
		if (Math.abs(_d) < EPS) {
			//Result := 1
			if (Self.BoxvsPoint(_mge_vec3, _mge_vec4, _mge_vec1) == true) { return true; }
				else if (Self.BoxvsPoint(_mge_vec3, _mge_vec4, _mge_vec2) == true) { return true; }
					else if (Self.BoxvsPoint(_mge_vec1, _mge_vec2, _mge_vec3) == true) { return true; }
						else if (Self.BoxvsPoint(_mge_vec1, _mge_vec2, _mge_vec4) == true) { return true; }
							else { return false; }
		} else {
			_ta = _da / _d;
			_tb = _db / _d;
			if ((0 <= _ta) && (_ta <= 1) && (0 <= _tb) && (_tb <= 1)) {
				//Result := 2;
				_point[0] = _mge_vec1[0] + _ta * (_mge_vec2[0] - _mge_vec1[0]);
				_point[1] = _mge_vec1[1] + _ta * (_mge_vec2[1] - _mge_vec1[1]);
				return Self.BoxvsPoint(_mge_vec1, _mge_vec2, _point) && Self.BoxvsPoint(_mge_vec3, _mge_vec4, _point);
			} else {
				//Result := 0;
				return false;
			}
		}
	}
	
	Self.LinevsTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5) {
		if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
			else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec4, _mge_vec5) == true) { return true; }
				else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec5, _mge_vec3) == true) { return true; }
					else if (Self.PointvsTriangle(_mge_vec1, _mge_vec3, _mge_vec4, _mge_vec5) == true) { return true; }
						else { return false; }
	}
	
	Self.LinevsTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
			else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec4, _mge_vec5) == true) { return true; }
				else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec5, _mge_vec6) == true) { return true; }
					else if (Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec6, _mge_vec3) == true) { return true; }
						else if (Self.PointvsTriangle(_mge_vec1, _mge_vec3, _mge_vec4, _mge_vec5) == true) { return true; }
							else if (Self.PointvsTriangle(_mge_vec1, _mge_vec5, _mge_vec6, _mge_vec4) == true) { return true; }
								else { return false; }
	}
	
	//** Collision Sphere
	
	Self.SpherevsSphere = function (_mge_vec1, _mge_rad1, _mge_vec2, _mge_rad2) {
		return Self.PointDistPoint(_mge_vec1, _mge_vec2) <= _mge_rad1 * _mge_rad2;
	}
	
	//** Collision Triangle
	
	Self.TrianglevsSphere = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_rad) {
		if (Self.LinevsSphere(_mge_vec1, _mge_vec2, _mge_vec4, _mge_rad) == true) { return true; }
			else if (Self.LinevsSphere(_mge_vec2, _mge_vec3, _mge_vec4, _mge_rad) == true) { return true; }
				else if (Self.LinevsSphere(_mge_vec3, _mge_vec1, _mge_vec4, _mge_rad) == true) { return true; }
					else if (Self.PointvsTriangle(_mge_vec4, _mge_vec1, _mge_vec2, _mge_vec3) == true) { return true; }
						else { return false; }
	}
	
	Self.TrianglevsTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		if (Self._LinevsTriangleLines(_mge_vec1, _mge_vec2, _mge_vec4, _mge_vec5, _mge_vec6) == true) { return true; }
			else if (Self._LinevsTriangleLines(_mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) == true) { return true; }
				else if (Self._LinevsTriangleLines(_mge_vec3, _mge_vec1, _mge_vec4, _mge_vec5, _mge_vec6) == true) { return true; }
					else if (Self.PointvsTriangle(_mge_vec1, _mge_vec4, _mge_vec5, _mge_vec6) == true) { return true; }
						else if (Self.PointvsTriangle(_mge_vec4, _mge_vec1, _mge_vec2, _mge_vec3) == true) { return true; }
							else { return false; }
	}
	
	//** Collision Tetragon
	
	Self.TetragonvsSphere = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_rad) {
		if (Self.LinevsSphere(_mge_vec1, _mge_vec2, _mge_vec5, _mge_rad) == true) { return true; }
			else if (Self.LinevsSphere(_mge_vec2, _mge_vec3, _mge_vec5, _mge_rad) == true) { return true; }
				else if (Self.LinevsSphere(_mge_vec3, _mge_vec4, _mge_vec5, _mge_rad) == true) { return true; }
					else if (Self.LinevsSphere(_mge_vec4, _mge_vec1, _mge_vec5, _mge_rad) == true) { return true; }
						else if (Self.PointvsTriangle(_mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3) == true) { return true; }
							else if (Self.PointvsTriangle(_mge_vec5, _mge_vec3, _mge_vec4, _mge_vec1) == true) { return true; }
								else { return false; }
	}
	
	Self.TetragonvsTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7) {
		if (Self._LinevsTetragonLines(_mge_vec5, _mge_vec6, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
			else if (Self._LinevsTetragonLines(_mge_vec6, _mge_vec7, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
				else if (Self._LinevsTetragonLines(_mge_vec7, _mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
					else if (Self.PointvsTetragon(_mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
						else if (Self.PointvsTriangle(_mge_vec1, _mge_vec5, _mge_vec6, _mge_vec7) == true) { return true; }
							else { return false; }
	}
	
	Self.TetragonvsTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8) {
		if (Self._LinevsTetragonLines(_mge_vec5, _mge_vec6, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
			else if (Self._LinevsTetragonLines(_mge_vec6, _mge_vec7, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
				else if (Self._LinevsTetragonLines(_mge_vec7, _mge_vec8, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
					else if (Self._LinevsTetragonLines(_mge_vec8, _mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
						else if (Self.PointvsTetragon(_mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) == true) { return true; }
							else if (Self.PointvsTetragon(_mge_vec1, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8) == true) { return true; }
								else { return false; }
	}
	
	//** Collision for collision types
	//** parameters send "next after previous"
	Self.AABBvsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsAABB( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_BOX: {
				return Self.AABBvsBox( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_POINT: {
				return Self.AABBvsPoint( _mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_LINE: {
				return Self.AABBvsLine( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_SPHERE: {
				return Self.AABBvsSphere( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4[0]);
			}
			case COLL_TRIANGLE: {
				return Self.AABBvsTriangle( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5);
			}
			case COLL_TETRAGON: {
				return Self.AABBvsTetragon( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6);
			}
		}
	}
	
	Self.BoxvsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsBox(_mge_vec3, _mge_vec4, _mge_vec1, _mge_vec2);
			}
			case COLL_BOX: {
				return Self.BoxvsBox(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_POINT: {
				return Self.BoxvsPoint(_mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_LINE: {
				return Self.BoxvsLine(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_SPHERE: {
				return Self.BoxvsSphere(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4[0]);
			}
			case COLL_TRIANGLE: {
				return Self.BoxvsTriangle( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5);
			}
			case COLL_TETRAGON: {
				return Self.BoxvsTetragon( _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6);
			}
		}
	}
	
	Self.PointvsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsPoint(_mge_vec2, _mge_vec3, _mge_vec1);
			}
			case COLL_BOX: {
				return Self.BoxvsPoint(_mge_vec2, _mge_vec3, _mge_vec1);
			}
			case COLL_POINT: {
				return Self.PointvsPoint(_mge_vec1, _mge_vec2);
			}
			case COLL_LINE: {
				return Self.PointvsLine(_mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_SPHERE: {
				return Self.PointvsSphere(_mge_vec1, _mge_vec2, _mge_vec3[0]);
			}
			case COLL_TRIANGLE: {
				return Self.PointvsTriangle(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_TETRAGON: {
				return Self.PointvsTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5);
			}
		}
	}
	
	Self.LinevsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsLine(_mge_vec3, _mge_vec4, _mge_vec1, _mge_vec2);
			}
			case COLL_BOX: {
				return Self.BoxvsLine(_mge_vec3, _mge_vec4, _mge_vec1, _mge_vec2);
			}
			case COLL_POINT: {
				return Self.PointvsLine(_mge_vec3, _mge_vec1, _mge_vec2);
			}
			case COLL_LINE: {
				return Self.LinevsLine(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_SPHERE: {
				return Self.LinevsSphere(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4[0]);
			}
			case COLL_TRIANGLE: {
				return Self.LinevsTriangle(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5);
			}
			case COLL_TETRAGON: {
				return Self.LinevsTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6);
			}
		}
	}
	
	Self.SpherevsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsSphere(_mge_vec3, _mge_vec4, _mge_vec1, _mge_vec2[0]);
			}
			case COLL_BOX: {
				return Self.BoxvsSphere(_mge_vec3, _mge_vec4, _mge_vec1, _mge_vec2[0]);
			}
			case COLL_POINT: {
				return Self.PointvsSphere(_mge_vec3, _mge_vec1, _mge_vec2[0]);
			}
			case COLL_LINE: {
				return Self.LinevsSphere(_mge_vec3, _mge_vec4, _mge_vec1, _mge_vec2[0]);
			}
			case COLL_SPHERE: {
				return Self.SpherevsSphere(_mge_vec1, _mge_vec2[0], _mge_vec3, _mge_vec4[0]);
			}
			case COLL_TRIANGLE: {
				return Self.TrianglevsSphere(_mge_vec3, _mge_vec4, _mge_vec5, _mge_vec1, _mge_vec2[0]);
			}
			case COLL_TETRAGON: {
				return Self.TetragonvsSphere(_mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec1, _mge_vec2[0]);
			}
		}
	}
	
	Self.TrianglevsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsTriangle(_mge_vec4, _mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_BOX: {
				return Self.BoxvsTriangle(_mge_vec4, _mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_POINT: {
				return Self.PointvsTriangle(_mge_vec4, _mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_LINE: {
				return Self.LinevsTriangle(_mge_vec4, _mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3);
			}
			case COLL_SPHERE: {
				return Self.TrianglevsSphere(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5[0]);
			}
			case COLL_TRIANGLE: {
				return Self.TrianglevsTriangle(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6);
			}
			case COLL_TETRAGON: {
				return Self.TetragonvsTriangle(_mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec1, _mge_vec2, _mge_vec3);
			}
		}
	}
	
	Self.TetragonvsCollType = function (_mge_coll_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8) {
		switch (_mge_coll_type) {
			case COLL_AABB: {
				return Self.AABBvsTetragon(_mge_vec5, _mge_vec6, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_BOX: {
				return Self.BoxvsTetragon(_mge_vec5, _mge_vec6, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_POINT: {
				return Self.PointvsTetragon(_mge_vec5, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_LINE: {
				return Self.LinevsTetragon(_mge_vec5, _mge_vec6, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
			case COLL_SPHERE: {
				return Self.TetragonvsSphere(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6[0]);
			}
			case COLL_TRIANGLE: {
				return Self.TetragonvsTriangle(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7);
			}
			case COLL_TETRAGON: {
				return Self.TetragonvsTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
		}
	}
	
	//** CollType vs CollType
	// Parameters send 1 - (1..4), 2 - (5..8)                             //1                                         //2
	Self.CollTypevsCollType = function (_mge_coll_type1, _mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8) {
		switch (_mge_coll_type1) {
			case COLL_AABB: {
				return Self.AABBvsCollType(_mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
			case COLL_BOX: {
				return Self.BoxvsCollType(_mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
			case COLL_POINT: {
				return Self.PointvsCollType(_mge_coll_type2, _mge_vec1, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
			case COLL_LINE: {
				return Self.LinevsCollType(_mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
			case COLL_SPHERE: {
				return Self.SpherevsCollType(_mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
			case COLL_TRIANGLE: {
				return Self.TrianglevsCollType(_mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
			case COLL_TETRAGON: {
				return Self.TetragonvsCollType(_mge_coll_type2, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _mge_vec5, _mge_vec6, _mge_vec7, _mge_vec8);
			}
		}
	}
	
}

Math2D = new MGEMath2D();

/*
const COLL_AABB = 1;
const COLL_BOX = 2;
const COLL_POINT = 3;
const COLL_LINE = 4;
const COLL_SPHERE = 5;
const COLL_TRIANGLE = 6;
const COLL_TETRAGON = 7;
*/

//alert("Math2D");

//alert( Math2D.PointDistLine2( [50, 50], [0, 0], [100, 100] ) );

//alert( Math2D.AABBvsAABB( [0, 0], [50, 50], [50, 50], [100, 100] ) );
//alert( Math2D.AABBvsLine( [0, 0], [50, 50], [250, 250], [270, 280] ) );
//alert( Math2D.AABBvsSphere( [0, 0], [50, 50], [205, 205], 10 ) );

//alert( Math2D.BoxvsPoint( [0, 0], [50, 50], [20, 20]) );

//alert( Math2D.PointvsPoint( [0, 0], [50, 50]) );
//alert( Math2D.PointvsLine( [30, 30], [0, 0], [50, 50] ) );

//alert( Math2D.PointvsTriangle( [25, 25], [0, 0], [50, 50], [0, 50] ) );
//alert( Math2D.PointvsTetragon( [0, 50], [0, 0], [50, 50], [50, 0], [0, 50] ) );

//alert( Math2D.LinevsLine( [0, 0], [10, 10], [-30, 5], [30, 5] ) );
//alert( Math2D.LinevsLine( [0, 0], [10, 10], [0, 0], [10, 10] ) );
//alert( Math2D.LinevsLine( [0, 0], [10, 0], [0, 0], [10, 0] ) );
//alert( Math2D.LinevsLine( [0, 0], [10, 0], [1, 1], [10, 0] ) );
//alert( Math2D.LinevsLine( [0, 0], [10, 0], [0, 1], [10, -1] ) );

//alert( Math2D.TetragonvsTriangle( [10, 0], [100, 0], [100, 100], [10, 100],      [-50, 5], [200, 10], [200, 30]) );
//alert( Math2D.TetragonvsTetragon( [0, 0], [100, 0], [100, 100], [0, 100],      [200, 200], [300, 0], [300, 300], [0, 300]) );

/*var _a = [0, 0];
var _b = [0, 5];
var _c = [5, 5];
var _d = [5, 0];
Math2D.SetTetragonCCW(_a, _b, _c, _d);
alert( Vec.GetString2( _a ) );
alert( Vec.GetString2( _b ) );
alert( Vec.GetString2( _c ) );
alert( Vec.GetString2( _d ) );*/

//
/*	alert( Math2D.CollTypevsCollType(COLL_TETRAGON, COLL_TETRAGON,		[0, 0], [100, 0], [100, 100], [0, 100],		[200, 200], [300, 0], [300, 300], [0, 300]) );

for ( var i = 1000; i >= 0; i--) {
	Math2D.CollTypevsCollType(COLL_TETRAGON, COLL_TETRAGON,		[0, 0], [100, 0], [100, 100], [0, 100],		[200, 200], [300, 0], [300, 300], [0, 300])
}
	alert( Math2D.CollTypevsCollType(COLL_TETRAGON, COLL_TETRAGON,		[0, 0], [100, 0], [100, 100], [0, 100],		[200, 200], [300, 0], [300, 300], [0, 300]) );
*/























