// Make-Games.ru [Constructor, ]
// Ver 0.0.1
// math2d;

//** User events id (const)
var ProcCreateEventID          = 0;
var ProcDestroyEventID         = 1;
var ProcDrawEventID            = 2;
var ProcBeginStepEventID       = 3;
var ProcStepEventID            = 4;
var ProcEndStepEventID         = 5;
var ProcCollisionEventID       = 6;
var ProcUserEventID            = 7;
var ProcMouseClickEventID      = 8;
var ProcMouseCollisionEventID  = 9;

var GlobalObjectsCount = 0;

function CreateGlobalObject () {
	var _obj = new MGEGlobalObject();
	GlobalObjectsCount += 1;
	_obj.ID = GlobalObjectsCount;
	//alert(_obj.ID);
	return _obj;
}

function ClearGlobalObjects () {
	GlobalObjectsCount = 0;
}

//** Collision type for more objects
function MGECollisionType () {
	//** Collision type
	this.CollisionType = 0;
	//** Collision points
	this.CollisionVec1 = [0.0, 0.0];
	this.CollisionVec2 = [0.0, 0.0];
	this.CollisionVec3 = [0.0, 0.0];
	this.CollisionVec4 = [0.0, 0.0];

	//**
	this.Clear = function () {
		//** Collision type
		this.CollisionType = 0;
		//** Collision points
		this.CollisionVec1[0] = 0.0;
		this.CollisionVec1[1] = 0.0;
		this.CollisionVec2[0] = 0.0;
		this.CollisionVec2[1] = 0.0;
		this.CollisionVec3[0] = 0.0;
		this.CollisionVec3[1] = 0.0;
		this.CollisionVec4[0] = 0.0;
		this.CollisionVec4[1] = 0.0;
	}
	
	//**
	this.Free = function () {
		this.CollisionVec1 = null;
		this.CollisionVec2 = null;
		this.CollisionVec3 = null;
		this.CollisionVec4 = null;
	}
}

//** Game global object
function MGEGlobalObject () {
	var Self = this;
	
	//** Object global ID
	Self.ID = -1;
	
	//** Object name
	Self.Name = null;
	
	//** Scene
	Self.Scene = null;
	Self.IDInScene = -1;
	
	//** Collision
	Self.CollisionData = null;
	
	//** Collision global objects array
	Self.CollisionObjectsCount = 0;
	Self.CollisionObjects = [];
	Self.TestSelfCollision = false;

	//** Child objects array
	Self.UseCacheObjects = true; // all objects not del, only call Clear
	Self.ObjectsCount = 0;
	Self.ObjectsMaxCount = 0;
	Self.Objects = [];
	
	//** Objects avail events
	Self.UseEvent = [false, // ProcCreateEvent
					false,  // ProcDestroyEvent
					true,   // ProcDrawEvent
					false,  // ProcBeginStepEvent
					false,  // ProcStepEvent
					false,  // ProcEndStepEvent
					false,  // ProcCollisionEvent
					false,  // ProcUserEvent
					false,  // ProcMouseClickEvent
					false]; // ProcMouseCollisionEvent
	
	//** Add/Del objects
	Self.ObjectAdd = function () {
		var _obj;
		if ((Self.UseCacheObjects === true) && (Self.ObjectsMaxCount > Self.ObjectsCount)) {
			_obj = Self.Objects[Self.ObjectsCount];
			//alert("Recreate");
		} else {
			_obj = new MGEObject();
			Self.Objects[Self.ObjectsCount] = _obj;
			//alert("New");
		}
		_obj.IDInParent = Self.ObjectsCount;
		_obj.Parent = Self;
		_obj.CollisionData = Self.CollisionData;
		Self.ObjectsCount += 1;
		if (Self.ObjectsMaxCount < Self.ObjectsCount) {
			Self.ObjectsMaxCount = Self.ObjectsCount;
		}
		//alert("Create Object ID : " + _obj.IDInParent);
		return _obj;
	}
	
	Self.ObjectDel = function (_mge_object_id) {
		var _obj;
		//alert("Del ID : " + _mge_object_id);
		if ((_mge_object_id < 0) || (_mge_object_id >= Self.ObjectsCount)) { return; }
		_obj = Self.Objects[_mge_object_id];
		Self.ObjectsCount -= 1;
		if (_mge_object_id !== Self.ObjectsCount) {
			Self.Objects[Self.ObjectsCount].IDInParent = _mge_object_id;
			Self.Objects[_mge_object_id] = Self.Objects[Self.ObjectsCount];
		}
		if (Self.UseCacheObjects === true) {
			Self.Objects[Self.ObjectsCount] = _obj;
			_obj.Clear();
			//alert("Clear object!");
		} else {
			Self.Objects[Self.ObjectsCount] = null;
			_obj.Parent = null;
			_obj.IDInParent = -1;
			//+USE_FREE+//_obj.Free();
			//+USE_LENGTH+//Self.Objects.length = Self.ObjectsCount;
		}
		_obj = null;
	}
	
	//** Add/Del  collision objects
	Self.CollisionObjectAdd = function (_mge_global_object) {
		Self.CollisionObjects[Self.CollisionObjectsCount] = _mge_global_object;
		Self.CollisionObjectsCount += 1;
	}
	
	Self.CollisionObjectDel = function (_mge_object_global_id) {
		for ( var i = Self.CollisionObjectsCount - 1; i >= 0; i--) {
			if (Self.CollisionObjects[i].ID === _mge_object_global_id) {
				Self.CollisionObjectsCount -= 1;
				if (i !== Self.CollisionObjectsCount) {
					Self.CollisionObjects[i] = Self.CollisionObjects[Self.CollisionObjectsCount];
				}
				Self.CollisionObjects[Self.CollisionObjectsCount] = null;
				//+USE_LENGTH+//Self.CollisionObjects.length = Self.CollisionObjectsCount;
			}
		}
	}
	
	//** Objects Event
	Self.SendCreateEvent = function () {
		if (Self.UseEvent[ProcCreateEventID] === false) {return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcCreateEvent(Self.Objects[i]);
		}
	}
	
	Self.SendDestroyEvent = function () {
		if (Self.UseEvent[ProcDestroyEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDestroyEvent(Self.Objects[i]);
		}
	}
	
	Self.SendDrawEvent = function (_mge_renderer) {
		if (Self.UseEvent[ProcDrawEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDrawEvent(Self.Objects[i], _mge_renderer);
		}
	}
	
	Self.SendBeginStepEvent = function () {
		if (Self.UseEvent[ProcBeginStepEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcBeginStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendStepEvent = function () {
		if (Self.UseEvent[ProcStepEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendEndStepEvent = function () {
		if (Self.UseEvent[ProcEndStepEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcEndStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendCollisionEvent = function (_mge_other) {
		if (Self.UseEvent[ProcCollisionEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcCollisionEvent(Self.Objects[i], _mge_other);
		}
	}
	
	Self.SendUserEvent = function () {
		if (Self.UseEvent[ProcUserEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcUserEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseEnterEvent = function () {
		if (Self.UseEvent[ProcMouseCollisionEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseEnterEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseLeaveEvent = function () {
		if (Self.UseEvent[ProcMouseCollisionEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseLeaveEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseClickEvent = function () {
		if (Self.UseEvent[ProcMouseClickEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseClickEvent(Self.Objects[i]);
		}
	}
	
	//**
	Self.CollisionStep = function () {
		if (Self.UseEvent[ProcCollisionEventID] === false) { return; }
		if (Self.TestSelfCollision === true) { Self.SelfCollision(); }
		if (Self.CollisionObjectsCount > 0) {
			for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
				for ( var j = Self.CollisionObjectsCount - 1; j >= 0; j--) {
					Self.CollisionObjects[j].ObjectCollision(Self.Objects[i]);
				}
			}
		}
	}
	
	Self.MouseCollisionStep = function (_mge_mouse_pos) {
		if (Self.UseEvent[ProcMouseCollisionEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].MouseCollisionStep(_mge_mouse_pos);
		}
	}
	
	Self.MouseClickStep = function (_mge_mouse_pos) {
		if (Self.UseEvent[ProcMouseClickEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].MouseClickStep(_mge_mouse_pos);
		}
	}
	
	//**
	Self.ObjectCollision = function (_mge_object) {
		if (Self.UseEvent[ProcCollisionEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].CollisionStep(_mge_object);
		}
	}
	
	Self.CollisionClear = function () {
		if (Self.UseEvent[ProcCollisionEventID] === false) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].CollisionClear();
		}
	}
	
	Self.SelfCollision = function () {
		if ((Self.UseEvent[ProcCollisionEventID] === false) || (Self.ObjectsCount < 2)) { return; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			for ( var j = i - 1; j >= 0; j--) {
				//alert("Object : " + i + " collided with object : " + j);
				if (Self.Objects[i].TestCollisionWithObject(Self.Objects[j]) === true) {
					//alert("find collision");
					Self.Objects[i].ProcCollisionEvent(Self, Self.Objects[j]);
					Self.Objects[j].ProcCollisionEvent(Self, Self.Objects[i]);
					
				}
			}
		}
	}
	
	//** Test cillision, no events. Return object ot null.
	Self.TestCollisionWithObject = function (_mge_object) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithObject(_mge_object) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithCollisionTypeAABB = function (_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithCollisionTypeAABB(_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithCollisionType = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithCollisionType(_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	//**
	Self.TestCollisionWithAABB = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithAABB(_mge_vec1, _mge_vec2) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithBox = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithBox(_mge_vec1, _mge_vec2) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithPoint = function (_mge_vec1) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithPoint(_mge_vec1) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithLine = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithLine(_mge_vec1, _mge_vec2) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithSphere = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithSphere(_mge_vec1, _mge_vec2) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithTriangle(_mge_vec1, _mge_vec2, _mge_vec3) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	Self.TestCollisionWithTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return Self.Objects[i]; }
		}
		return null;
	}
	
	//** Search global object in list. Return True or False.
	Self.IsGlobalObjectInCollisionList = function (_mge_global_object) {
		for ( var i = Self.CollisionObjectsCount - 1; i >= 0; i--) {
			if (Self.CollisionObjects[i].ID === _mge_global_object.ID) {
				return true;
			}
		}
		return false;
	}
	
	//** Clear mouse Enter
	Self.ClearMouseEnter = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].MouseEnter = false;
		}
	}
	
	Self.Clear = function () {
		//** Object global ID
		Self.ID = -1;
		//** Object name
		Self.Name = null;
		//** Scene
		Self.Scene = null;
		Self.IDInScene = -1;
		//** Collision
		Self.CollisionData = null;
		//** Collision global objects array
		Self.CollisionObjectsCount = 0;
		//+USE_NEW_ARRAY+//Self.CollisionObjects = [];
		//+USE_LENGTH+//Self.CollisionObjects.length = 0;
		Self.TestSelfCollision = false;
		//** Child objects array
		Self.UseCacheObjects = true;
		Self.ObjectsCount = 0;
		Self.ObjectsMaxCount = 0;
		//+USE_NEW_ARRAY+//Self.Objects = [];
		//+USE_LENGTH+//Self.Objects.length = 0;
		//** Objects avail events
		Self.UseEvent = [false, // ProcCreateEvent
						false,  // ProcDestroyEvent
						true,   // ProcDrawEvent
						false,  // ProcBeginStepEvent
						false,  // ProcStepEvent
						false,  // ProcEndStepEvent
						false,  // ProcCollisionEvent
						false,  // ProcUserEvent
						false,  //ProcMouseClickEvent
						false]; //ProcMouseCollisionEvent
	}
	
	Self.Free = function () {
		Self.Name = null;
		Self.Scene = null;
		Self.CollisionData = null;
		Self.CollisionObjects = null;
		Self.Objects = null;
	}
	
}

//** Game object
function MGEObject() {
	var Self = this;
	
	//** Object name
	Self.Name = null;
	
	//** Parent object
	Self.Parent = null;
	Self.IDInParent = -1;
	
	//** ID in Scene
	Self.IDInScene = -1;
	
	//** Layer
	Self.LayerID = -1;
	Self.IDInLayer = -1;
	
	//** Sprite
	Self.Sprite = null;

	//** States
	Self.Visible = true;
	Self.Enable = true;
	Self.Solid = false;
	
	//** Param
	Self.Angle = 0;
	Self.Position = [0, 0];
	Self.Center = [0, 0];
	Self.Size = [0, 0];
	Self.Scale = [1, 1];
	
	//** Cache
	Self.CacheCenter = [0, 0];
	Self.CachePosition = [0, 0];
	Self.CacheSize = [0, 0];
	Self.PrePosition = [0, 0];
	Self.CacheCollisionVec1 = [0, 0];
	Self.CacheCollisionVec2 = [0, 0];
	Self.CacheCollisionVec3 = [0, 0];
	Self.CacheCollisionVec4 = [0, 0];
	Self.CacheCenterPosition = [0, 0];
	
	//** Collision
	Self.CollisionData = null;
		
	//** PreCollision
	Self.MinVector = [0.0, 0.0];
	Self.MaxVector = [0.0, 0.0];
	Self.Radius = 0;
	
	//** Mouse
	Self.MouseEnter = false;
	
	//**
	Self.Velocity = [0.0, 0.0];
	Self.ZIndex = 0;
	
	//**
	Self.CollidedObjectsCount = 0;
	
	//** TMP Position for Test Collision
	Self.TempVector = [0.0, 0.0];
	
	//**
	Self.Variables = null;
		
	//** User events
	Self.ProcCreateEvent = function (_mge_sender) {  }
	Self.ProcDestroyEvent = function (_mge_sender) {  }
	Self.ProcDrawEvent = function (_mge_sender, _mge_renderer) {
		if ((_mge_sender.Visible === false) || (_mge_sender.Sprite === null) || (_mge_renderer === null)) { return; }
		if (CurCamera !== null) {
			if (Math2D.AABBvsAABB(_mge_sender.MinVector, _mge_sender.MaxVector, CurCamera.MinVector, CurCamera.MaxVector) === false) { return; }
		}
		_mge_renderer.DrawSpriteEx(_mge_sender.Sprite.Image, _mge_sender.Sprite.SourcesPosition, _mge_sender.Sprite.SourcesSize, _mge_sender.CachePosition, _mge_sender.CacheSize, _mge_sender.CacheCenter, _mge_sender.Angle);
	}
	Self.ProcBeginStepEvent = function (_mge_sender) {  }
	Self.ProcStepEvent = function (_mge_sender) { 
		if (_mge_sender.Sprite !== null) { 
			_mge_sender.Sprite.Step();
		}
		if ((Self.Velocity[0] !== 0) || (Self.Velocity[1] !== 0)) {
			Self.SetPosition(Self.Position[0] + Self.Velocity[0], Self.Position[1] + Self.Velocity[1]);
		}
	}
	Self.ProcEndStepEvent = function (_mge_sender) {  }
	Self.ProcCollisionEvent = function (_mge_sender, _mge_other) {  }
	Self.ProcUserEvent = function (_mge_sender, _mge_event_num, _mge_event_param) {  }
	Self.ProcMouseEnter = function (_mge_sender) {  }
	Self.ProcMouseLeave = function (_mge_sender) {  }
	Self.ProcMouseClick = function (_mge_sender) {  }
	Self.ProcOnTimer = function (_mge_sender, _mge_param) {  }

	//**
	Self.DrawPreCollisionMask = function (_mge_renderer) {
		_mge_renderer.BeginPath();
			_mge_renderer.Box(Self.MinVector, Self.MaxVector);
		_mge_renderer.EndPath();
		_mge_renderer.Stroke();
	}
	
	Self.DrawCollisionMask = function (_mge_renderer) {
		_mge_renderer.DrawCollisionMask(Self.CollisionData.CollisionType, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	//**
	Self.CollisionStep = function (_mge_object) {
		if (Self.ObjectCollision(_mge_object) === true) {
			//alert(Self.Name + " send collision event");
			Self.ProcCollisionEvent(Self, _mge_object);
			_mge_object.ProcCollisionEvent(_mge_object, Self);
		}
	}
	
	Self.MouseCollisionStep = function (_mge_mouse_pos) {
		var _result = Self.TestCollisionWithPoint(_mge_mouse_pos);
		if (_result === Self.MouseEnter) { return _result; }
		Self.MouseEnter = _result;
		if (_result === true) {
			Self.ProcMouseEnter(Self);
		} else {
			Self.ProcMouseLeave(Self);
		}
		return _result;
	}
	
	Self.MouseClickStep = function (_mge_mouse_pos) {
		if(Self.TestCollisionWithPoint(_mge_mouse_pos) === true) {
			Self.MouseEnter = true;
			Self.ProcMouseClick(Self);
		} else {
			Self.MouseEnter = false;
		}
	}
	
	//**
	Self.ObjectCollision = function (_mge_object) {
		//alert("Test collision : " + Self.Name + " with: " + _mge_object.Name);
		Self.CollidedObjectsCount += 1;
		var _result = false;
		if (_mge_object.IDInScene === Self.IDInScene) { return true; }
		// test collision
		_result = Self.TestCollisionWithObject(_mge_object);
		//_result = false;
		//alert("Result = " + _result);
		return _result;
	}
	
	Self.CollisionClear = function () {
		Self.CollidedObjectsCount = 0;
	}
	
	//**
	Self.TestCollisionWithObject = function (_mge_object) {
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_object.MinVector, _mge_object.MaxVector) === true) {
			//alert("AABB vs AABB = true");
			if (Self.CollisionData.CollisionType === COLL_AABB) {
				if (_mge_object.CollisionData.CollisionType === COLL_AABB) {
					//alert("AABB vs AABB");
					return true;
				} else {
					//alert("AABB vs CollType");
					return Math2D.AABBvsCollType(_mge_object.CollisionData.CollisionType, Self.CacheCollisionVec1, Self.CacheCollisionVec2, _mge_object.CacheCollisionVec1, _mge_object.CacheCollisionVec2, _mge_object.CacheCollisionVec3, _mge_object.CacheCollisionVec4);
				}
			} else {
				if (_mge_object.CollisionData.CollisionType === COLL_AABB) {
					//alert("CollType vs AABB");
					return Math2D.AABBvsCollType(Self.CollisionData.CollisionType, _mge_object.CacheCollisionVec1, _mge_object.CacheCollisionVec2, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
				} else {
					//alert("CollType vs CollType");
					return Math2D.CollTypevsCollType(Self.CollisionData.CollisionType, _mge_object.CollisionData.CollisionType, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4, _mge_object.CacheCollisionVec1, _mge_object.CacheCollisionVec2, _mge_object.CacheCollisionVec3, _mge_object.CacheCollisionVec4);	
				}
			}
		} else {
			//alert("AABB vs AABB = false");
			return false;
		}
	}
	
	Self.TestCollisionWithCollisionTypeAABB = function (_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_min_vec, _mge_max_vec) === true) {
			return Self.TestCollisionWithCollisionType(_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
		} else {
			//alert("AABB vs AABB = false");
			return false;
		}
	}
	
	Self.TestCollisionWithCollisionType = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		//alert("AABB vs AABB = true");
		if (Self.CollisionData.CollisionType === COLL_AABB) {
			if (_mge_collision_type === COLL_AABB) {
				//alert("AABB vs AABB");
				return true;
			} else {
				//alert("AABB vs CollType");
				return Math2D.AABBvsCollType(_mge_collision_type, Self.CacheCollisionVec1, Self.CacheCollisionVec2, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
			}
		} else {
			if (_mge_collision_type === COLL_AABB) {
				//alert("CollType vs AABB");
				return Math2D.AABBvsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
			} else {
				//alert("CollType vs CollType");
				return Math2D.CollTypevsCollType(Self.CollisionData.CollisionType, _mge_collision_type, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);	
			}
		}
	}
	
	//**
	Self.TestCollisionWithAABB = function (_mge_vec1, _mge_vec2) {
		return Math2D.AABBvsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	Self.TestCollisionWithBox = function (_mge_vec1, _mge_vec2) {
		return Math2D.BoxvsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	Self.TestCollisionWithPoint = function (_mge_vec1) {
		return Math2D.PointvsCollType(Self.CollisionData.CollisionType, _mge_vec1, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	Self.TestCollisionWithLine = function (_mge_vec1, _mge_vec2) {
		return Math2D.LinevsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	Self.TestCollisionWithSphere = function (_mge_vec1, _mge_vec2) {
		return Math2D.SpherevsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	Self.TestCollisionWithTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		return Math2D.TrianglevsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, _mge_vec3, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	Self.TestCollisionWithTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		return Math2D.TetragonvsCollType(Self.CollisionData.CollisionType, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, Self.CacheCollisionVec1, Self.CacheCollisionVec2, Self.CacheCollisionVec3, Self.CacheCollisionVec4);
	}
	
	//**
	Self.SetTempPosition = function (_mge_vector) {
		Self.TempVector[0] = -_mge_vector[0];
		Self.TempVector[1] = -_mge_vector[1];
		//
		Self.MinVector[0] += _mge_vector[0];
		Self.MinVector[1] += _mge_vector[1];
		Self.MaxVector[0] += _mge_vector[0];
		Self.MaxVector[1] += _mge_vector[1];
		//
		Self.AddCollisionVec(_mge_vector);
	}
	
	Self.ClearTempPosition = function () {
		Self.MinVector[0] += Self.TempVector[0];
		Self.MinVector[1] += Self.TempVector[1];
		Self.MaxVector[0] += Self.TempVector[0];
		Self.MaxVector[1] += Self.TempVector[1];
		//
		Self.AddCollisionVec(Self.TempVector);
		//
		Self.TempVector[0] = 0;
		Self.TempVector[1] = 0;
	}

	//**
	Self.UpdateCache = function () {
		Self.CacheCenter = [Self.Center[0], Self.Center[1]];
		Self.CachePosition = [Self.Position[0] - Self.CacheCenter[0], Self.Position[1] - Self.CacheCenter[1]];
		Self.CacheSize = [Self.Size[0], Self.Size[1]];
		Self.PrePosition = [Self.CachePosition[0], Self.CachePosition[1]];
		Self.UpdatePreCollision();
		Self.UpdateCollision();
	}
	
	Self.UpdatePrePosition = function () {
		Self.PrePosition[0] = Self.Position[0];
		Self.PrePosition[1] = Self.Position[1];
	}
	
	Self.UpdateCachePosition = function () {
		Self.CachePosition[0] = Self.Position[0] - Self.CacheCenter[0];
		Self.CachePosition[1] = Self.Position[1] - Self.CacheCenter[1];
	}
	
	Self.UpdatePreCollision = function () {
		Self.CacheCenterPosition = [Self.CacheSize[0] / 2, Self.CacheSize[1] / 2];
		Self.Radius = Math2D.PointDistPoint(Self.CacheCenterPosition, Self.CacheSize);
		Self.CacheCenterPosition = [Self.CacheCenterPosition[0] + Self.CachePosition[0], Self.CacheCenterPosition[1] + Self.CachePosition[1]];
		Math2D.PointRotate(Self.CacheCenterPosition, Self.Position, Self.Angle + 0/*DEG2RAD90*/);
		Self.MinVector[0] = Self.CacheCenterPosition[0] - Self.Radius;
		Self.MinVector[1] = Self.CacheCenterPosition[1] - Self.Radius;
		Self.MaxVector[0] = Self.CacheCenterPosition[0] + Self.Radius;
		Self.MaxVector[1] = Self.CacheCenterPosition[1] + Self.Radius;
	}

	Self.UpdateCollision = function () {
		var _angle;
		switch (Self.CollisionData.CollisionType) {
			case COLL_AABB: {
				Self.CacheCollisionVec1[0] = Self.MinVector[0];
				Self.CacheCollisionVec1[1] = Self.MinVector[1];
				Self.CacheCollisionVec2[0] = Self.MaxVector[0];
				Self.CacheCollisionVec2[1] = Self.MaxVector[1];
				return;
			}
			case COLL_BOX: {
				Self.CacheCollisionVec1[0] = (Self.CollisionData.CollisionVec1[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec1[1] = (Self.CollisionData.CollisionVec1[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec2[0] = (Self.CollisionData.CollisionVec2[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec2[1] = (Self.CollisionData.CollisionVec2[1] * Self.Scale[1]) + Self.CachePosition[1];
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
				}
				return;
			}
			case COLL_POINT: {
				Self.CacheCollisionVec1[0] = (Self.CollisionData.CollisionVec1[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec1[1] = (Self.CollisionData.CollisionVec1[1] * Self.Scale[1]) + Self.CachePosition[1];
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
				}
				return;
			}
			case COLL_LINE: {
				Self.CacheCollisionVec1[0] = (Self.CollisionData.CollisionVec1[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec1[1] = (Self.CollisionData.CollisionVec1[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec2[0] = (Self.CollisionData.CollisionVec2[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec2[1] = (Self.CollisionData.CollisionVec2[1] * Self.Scale[1]) + Self.CachePosition[1];
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
				}
				return;
			}
			case COLL_SPHERE: {
				Self.CacheCollisionVec1[0] = (Self.CollisionData.CollisionVec1[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec1[1] = (Self.CollisionData.CollisionVec1[1] * Self.Scale[1]) + Self.CachePosition[1];
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
				}
				Self.CacheCollisionVec2[0] = Self.CollisionData.CollisionVec2[0] * Math2D.Max(Self.Scale[0], Self.Scale[1]);
				return;
			}
			case COLL_TRIANGLE: {
				Self.CacheCollisionVec1[0] = (Self.CollisionData.CollisionVec1[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec1[1] = (Self.CollisionData.CollisionVec1[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec2[0] = (Self.CollisionData.CollisionVec2[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec2[1] = (Self.CollisionData.CollisionVec2[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec3[0] = (Self.CollisionData.CollisionVec3[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec3[1] = (Self.CollisionData.CollisionVec3[1] * Self.Scale[1]) + Self.CachePosition[1];
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec3, Self.Position, _angle);
				}
				return;
			}
			case COLL_TETRAGON: {
				Self.CacheCollisionVec1[0] = (Self.CollisionData.CollisionVec1[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec1[1] = (Self.CollisionData.CollisionVec1[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec2[0] = (Self.CollisionData.CollisionVec2[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec2[1] = (Self.CollisionData.CollisionVec2[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec3[0] = (Self.CollisionData.CollisionVec3[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec3[1] = (Self.CollisionData.CollisionVec3[1] * Self.Scale[1]) + Self.CachePosition[1];
				Self.CacheCollisionVec4[0] = (Self.CollisionData.CollisionVec4[0] * Self.Scale[0]) + Self.CachePosition[0];
				Self.CacheCollisionVec4[1] = (Self.CollisionData.CollisionVec4[1] * Self.Scale[1]) + Self.CachePosition[1];
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec3, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec4, Self.Position, _angle);
				}
				return;
			}
		}
	}
	
	//**
	Self.AddCollisionAngle = function (_mge_angle) {
		switch (Self.CollisionData.CollisionType) {
			case COLL_AABB: {
				Self.CacheCollisionVec1[0] = Self.MinVector[0];
				Self.CacheCollisionVec1[1] = Self.MinVector[1];
				Self.CacheCollisionVec2[0] = Self.MaxVector[0];
				Self.CacheCollisionVec2[1] = Self.MaxVector[1];
				return;
			}
			case COLL_BOX: {
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
				}
				return;
			}
			case COLL_POINT: {
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
				}
				return;
			}
			case COLL_LINE: {
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
				}
				return;
			}
			case COLL_SPHERE: {
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
				}
				return;
			}
			case COLL_TRIANGLE: {
				if (Self.Angle !== 0.0) {
					_angle = Self.Angle + 0/*DEG2RAD90*/;
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _angle);
					Math2D.PointRotate(Self.CacheCollisionVec3, Self.Position, _angle);
				}
				return;
			}
			case COLL_TETRAGON: {
				if (_mge_angle !== 0.0) {
					Math2D.PointRotate(Self.CacheCollisionVec1, Self.Position, _mge_angle);
					Math2D.PointRotate(Self.CacheCollisionVec2, Self.Position, _mge_angle);
					Math2D.PointRotate(Self.CacheCollisionVec3, Self.Position, _mge_angle);
					Math2D.PointRotate(Self.CacheCollisionVec4, Self.Position, _mge_angle);
				}
				return;
			}
		}
	}
	
	Self.AddCollisionVec = function (_mge_vec) {
		switch (Self.CollisionData.CollisionType) {
			case COLL_AABB: {
				Self.CacheCollisionVec1[0] = Self.MinVector[0];
				Self.CacheCollisionVec1[1] = Self.MinVector[1];
				Self.CacheCollisionVec2[0] = Self.MaxVector[0];
				Self.CacheCollisionVec2[1] = Self.MaxVector[1];
				return;
			}
			case COLL_BOX: {
				Self.CacheCollisionVec1[0] += _mge_vec[0];
				Self.CacheCollisionVec1[1] += _mge_vec[1];
				Self.CacheCollisionVec2[0] += _mge_vec[0];
				Self.CacheCollisionVec2[1] += _mge_vec[1];
				return;
			}
			case COLL_POINT: {
				Self.CacheCollisionVec1[0] += _mge_vec[0];
				Self.CacheCollisionVec1[1] += _mge_vec[1];
				return;
			}
			case COLL_LINE: {
				Self.CacheCollisionVec1[0] += _mge_vec[0];
				Self.CacheCollisionVec1[1] += _mge_vec[1];
				Self.CacheCollisionVec2[0] += _mge_vec[0];
				Self.CacheCollisionVec2[1] += _mge_vec[1];
				return;
			}
			case COLL_SPHERE: {
				Self.CacheCollisionVec1[0] += _mge_vec[0];
				Self.CacheCollisionVec1[1] += _mge_vec[1];
				return;
			}
			case COLL_TRIANGLE: {
				Self.CacheCollisionVec1[0] += _mge_vec[0];
				Self.CacheCollisionVec1[1] += _mge_vec[1];
				Self.CacheCollisionVec2[0] += _mge_vec[0];
				Self.CacheCollisionVec2[1] += _mge_vec[1];
				Self.CacheCollisionVec3[0] += _mge_vec[0];
				Self.CacheCollisionVec3[1] += _mge_vec[1];
				return;
			}
			case COLL_TETRAGON: {
				Self.CacheCollisionVec1[0] += _mge_vec[0];
				Self.CacheCollisionVec1[1] += _mge_vec[1];
				Self.CacheCollisionVec2[0] += _mge_vec[0];
				Self.CacheCollisionVec2[1] += _mge_vec[1];
				Self.CacheCollisionVec3[0] += _mge_vec[0];
				Self.CacheCollisionVec3[1] += _mge_vec[1];
				Self.CacheCollisionVec4[0] += _mge_vec[0];
				Self.CacheCollisionVec4[1] += _mge_vec[1];
				return;
			}
		}
	}
	
	//**
	Self.SetScaleV = function (_mge_scale) {
		Self.SetScale(_mge_scale[0], _mge_scale[1]);
	}
	
	Self.SetScale = function (_mge_scale_x, _mge_scale_y) {
		Self.Scale[0] = _mge_scale_x;
		Self.Scale[1] = _mge_scale_y;
		Self.CacheSize[0] = Self.Size[0] * _mge_scale_x;
		Self.CacheSize[1] = Self.Size[1] * _mge_scale_y;
		Self.CacheCenter[0] = Self.Center[0] * _mge_scale_x;
		Self.CacheCenter[1] = Self.Center[1] * _mge_scale_y;
		Self.UpdateCachePosition();
		Self.UpdatePreCollision();
		//**
		Self.UpdateCollision();
	}
	
	Self.SetPositionV = function (_mge_pos) {
		Self.SetPosition(_mge_pos[0], _mge_pos[1]);
	}
	
	Self.SetPosition = function (_mge_x, _mge_y) {
		var _pos = [_mge_x - Self.Position[0], _mge_y - Self.Position[1]];
		if ((_pos[0] !== 0.0) || (_pos[1] !== 0.0)) {
			Self.UpdatePrePosition();
			Self.CacheCenterPosition[0] += _pos[0];
			Self.CacheCenterPosition[1] += _pos[1];
			Self.MinVector[0] = Self.CacheCenterPosition[0] - Self.Radius;
			Self.MinVector[1] = Self.CacheCenterPosition[1] - Self.Radius;
			Self.MaxVector[0] = Self.CacheCenterPosition[0] + Self.Radius;
			Self.MaxVector[1] = Self.CacheCenterPosition[1] + Self.Radius;
			Self.Position[0] = _mge_x;
			Self.Position[1] = _mge_y;
			Self.UpdateCachePosition();
			//**
			Self.AddCollisionVec(_pos);
		}
	}
	
	Self.SetAngle = function (_mge_angle) {
		var _ang = _mge_angle - Self.Angle;
		if (_ang !== 0.0) {
			_ang += 0/*DEG2RAD90*/;
			Math2D.PointRotate(Self.CacheCenterPosition, Self.Position, _ang);
			Self.MinVector[0] = Self.CacheCenterPosition[0] - Self.Radius;
			Self.MinVector[1] = Self.CacheCenterPosition[1] - Self.Radius;
			Self.MaxVector[0] = Self.CacheCenterPosition[0] + Self.Radius;
			Self.MaxVector[1] = Self.CacheCenterPosition[1] + Self.Radius;
			//**
			Self.AddCollisionAngle(_ang);
			Self.Angle = _mge_angle;
		}
	}
	
	Self.SetSizeV = function (_mge_size, _mge_update_collision) {
		Self.SetSize(_mge_size[0], _mge_size[1], _mge_update_collision);
	}
	
	Self.SetSize = function (_mge_size_x, _mge_size_y, _mge_update_collision) {
		var _scale_x, _scale_y;
		if (_mge_update_collision === true) {
			_scale_x = _mge_size_x / Self.Size[0];
			_scale_y = _mge_size_y / Self.Size[1];
			Self.SetScale(_scale_x, _scale_y);
		} else {
			Self.Size[0] = _mge_size_x;
			Self.Size[1] = _mge_size_y;
			Self.CacheSize = [Self.Size[0], Self.Size[1]];
		}
	}
	
	//**
	Self.Clear = function () {
		//** Object name
		Self.Name = null;
		//** Parent object
		Self.Parent = null;
		Self.IDInParent = -1;
		//** ID in Scene
		Self.IDInScene = -1;
		//** Layer
		Self.LayerID = -1;
		Self.IDInLayer = -1;
		//** Sprite
		Self.Sprite = null;
		//** States
		Self.Visible = true;
		Self.Enable = true;
		Self.Solid = false;
		//** Param
		Self.Angle = 0;
		Self.Position[0] = 0;
		Self.Position[1] = 0;
		Self.Center[0] = 0;
		Self.Center[1] = 0;
		Self.Size[0] = 0;
		Self.Size[1] = 0;
		Self.Scale[0] = 1;
		Self.Scale[1] = 1;
		//** Cache
		Self.CacheCenter[0] = 0;
		Self.CacheCenter[1] = 0;
		Self.CachePosition[0] = 0;
		Self.CachePosition[1] = 0;
		Self.CacheSize[0] = 0;
		Self.CacheSize[1] = 0;
		Self.PrePosition[0] = 0;
		Self.PrePosition[1] = 0;
		Self.CacheCollisionVec1[0] = 0;
		Self.CacheCollisionVec1[1] = 0;
		Self.CacheCollisionVec2[0] = 0;
		Self.CacheCollisionVec2[1] = 0;
		Self.CacheCollisionVec3[0] = 0;
		Self.CacheCollisionVec3[1] = 0;
		Self.CacheCollisionVec4[0] = 0;
		Self.CacheCollisionVec4[1] = 0;
		Self.CacheCenterPosition[0] = 0;
		Self.CacheCenterPosition[1] = 0;
		//** Collision
		Self.CollisionData = null;
		//**
		Self.CollidedObjectsCount = 0;
		//** PreCollision
		Self.MinVector[0] = 0;
		Self.MinVector[1] = 0;
		Self.MaxVector[0] = 0;
		Self.MaxVector[1] = 0;
		Self.Radius = 0;
		//**
		Self.Velocity[0] = 0.0;
		Self.Velocity[1] = 0.0;
		Self.ZIndex = 0;
		//** Mouse
		Self.MouseEnter = false;
		//**
		Self.TempVector[0] = 0.0;
		Self.TempVector[1] = 0.0;
		//** User events
		Self.ProcCreateEvent = function () {  }
		Self.ProcDestroyEvent = function () {  }
		Self.ProcDrawEvent = function (_mge_sender, _mge_renderer) {
			if ((_mge_sender.Visible === false) || (_mge_sender.Sprite === null) || (_mge_renderer === null)) { return; }
			if (CurCamera !== null) {
				if (Math2D.AABBvsAABB(_mge_sender.MinVector, _mge_sender.MaxVector, CurCamera.MinVector, CurCamera.MaxVector) === false) { return; }
			}
			_mge_renderer.DrawSpriteEx(_mge_sender.Sprite.Image, _mge_sender.Sprite.SourcesPosition, _mge_sender.Sprite.SourcesSize, _mge_sender.CachePosition, _mge_sender.CacheSize, _mge_sender.CacheCenter, _mge_sender.Angle);
		}
		Self.ProcBeginStepEvent = function (_mge_sender) {  }
		Self.ProcStepEvent = function (_mge_sender) { 
			if (_mge_sender.Sprite !== null) { 
				_mge_sender.Sprite.Step();
			}
		}
		Self.ProcEndStepEvent = function () {  }
		Self.ProcCollisionEvent = function (_mge_other) {  }
		Self.ProcUserEvent = function (_mge_event_num, _mge_event_param) {  }
		Self.ProcMouseEnter = function () {  }
		Self.ProcMouseLeave = function () {  }
		Self.ProcMouseClick = function () {  }
	}
	
	//**
	Self.Free = function () {
		Self.Name = null;
		Self.Parent = null;
		Self.Sprite = null;
		Self.CollisionData = null;
		Self.Position = null;
		Self.Center = null;
		Self.Size = null;
		Self.Scale = null;
		Self.CacheCenter = null;
		Self.CachePosition = null;
		Self.CacheSize = null;
		Self.PrePosition = null;
		Self.CacheCollisionVec1 = null;
		Self.CacheCollisionVec2 = null;
		Self.CacheCollisionVec3 = null;
		Self.CacheCollisionVec4 = null;
		Self.CacheCenterPosition = null;
		Self.MinVector = null;
		Self.MaxVector = null;
		Self.Velocity = null;
		Self.TempVector[0] = null;
	}
}



















