// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGEParticles() {
	var Self = this;
	
	//**
	Self.Position = [0.0, 0.0];
	Self.Count = 0;
	Self.MaxCount = 0;
	Self.Position_X = [];
	Self.Position_Y = [];
	Self.Velocity_X = [];
	Self.Velocity_Y = [];
	Self.Life = [];
	Self.SubLife = 0;
	Self.IDToDelete = -1;
	//**
	Self.Gravitation = [0.0, 0.0];
	//**
	Self.DrawEvent = function (_mge_sender, _mge_id) {  }
	Self.StepEvent = function (_mge_sender, _mge_id) {
		_mge_sender.Velocity_X[_mge_id] += _mge_sender.Gravitation[0];
		_mge_sender.Velocity_Y[_mge_id] += _mge_sender.Gravitation[1];
		_mge_sender.Position_X[_mge_id] += _mge_sender.Velocity_X[_mge_id];
		_mge_sender.Position_Y[_mge_id] += _mge_sender.Velocity_Y[_mge_id];
	}
	Self.DestroyEvent = function (_mge_sender, _mge_id) { return true; }
	
	//**
	Self.Initialize = function (_mge_max_count, _mge_sub_life, _mge_gravitation) {
		if (_mge_max_count > 0) {
			Self.Position_X.length = _mge_max_count;
			Self.Position_Y.length = _mge_max_count;
			Self.Velocity_X.length = _mge_max_count;
			Self.Velocity_Y.length = _mge_max_count;
			Self.Life.length = _mge_max_count;
		}
		Self.MaxCount = _mge_max_count;
		Self.SubLife = _mge_sub_life;
		Self.Gravitation[0] = _mge_gravitation[0];
		Self.Gravitation[1] = _mge_gravitation[1];
	}
	
	//**
	Self.Add = function (_mge_position, _mge_velocity, _mge_life) {
		var _cur_id;
		if (Self.IDToDelete !== -1) {
			_cur_id = Self.IDToDelete;
			Self.IDToDelete = -1;
		} else {
			if ((Self.MaxCount !== 0) && (Self.Count >= Self.MaxCount)) {return; }
			_cur_id = Self.Count;
		}
		Self.Count += 1;
		Self.Position_X[_cur_id] = _mge_position[0];
		Self.Position_Y[_cur_id] = _mge_position[1];
		Self.Velocity_X[_cur_id] = _mge_velocity[0];
		Self.Velocity_Y[_cur_id] = _mge_velocity[1];
		Self.Life[_cur_id] = _mge_life;
	}
	
	Self.SetParticle = function (_mge_id, _mge_position, _mge_velocity, _mge_life) {
		Self.Position_X[_mge_id] = _mge_position[0];
		Self.Position_Y[_mge_id] = _mge_position[1];
		Self.Velocity_X[_mge_id] = _mge_velocity[0];
		Self.Velocity_Y[_mge_id] = _mge_velocity[1];
		Self.Life[_mge_id] = _mge_life;
	}
	
	Self.Step = function () {
		for ( var i = Self.Count - 1; i >= 0; i--) {
			Self.Life[i] -= Self.SubLife;
			if (Self.Life[i] > 0) {
				Self.Velocity_X[i] += Self.Gravitation[0];
				Self.Velocity_Y[i] += Self.Gravitation[1];
				Self.Position_X[i] += Self.Velocity_X[i];
				Self.Position_Y[i] += Self.Velocity_Y[i];
			} else {
				Self.IDToDelete = i;
				Self.Count -= 1;
				Self.DestroyEvent(Self, Self.IDToDelete);
				if (Self.Life[i] <= 0) {
					if (i !== Self.Count) {
						Self.Position_X[i] = Self.Position_X[Self.Count];
						Self.Position_Y[i] = Self.Position_Y[Self.Count];
						Self.Velocity_X[i] = Self.Velocity_X[Self.Count];
						Self.Velocity_Y[i] = Self.Velocity_Y[Self.Count];
						Self.Life[i] = Self.Life[Self.Count];
					}
				}
				Self.IDToDelete = -1;
			}
		}
	}
	
	Self.StepWithEvent = function () {
		for ( var i = Self.Count - 1; i >= 0; i--) {
			Self.Life[i] -= Self.SubLife;
			if (Self.Life[i] > 0) {
				Self.StepEvent(Self, i);
			} else {
				Self.IDToDelete = i;
				Self.Count -= 1;
				Self.DestroyEvent(Self, Self.IDToDelete);
				if (Self.Life[i] <= 0) {
					if (i !== Self.Count) {
						Self.Position_X[i] = Self.Position_X[Self.Count];
						Self.Position_Y[i] = Self.Position_Y[Self.Count];
						Self.Velocity_X[i] = Self.Velocity_X[Self.Count];
						Self.Velocity_Y[i] = Self.Velocity_Y[Self.Count];
						Self.Life[i] = Self.Life[Self.Count];
					}
				}
				Self.IDToDelete = -1;
			}
		}
	}
	
	Self.Draw = function () {
		for ( var i = Self.Count - 1; i >= 0; i--) {
			Self.DrawEvent(Self, i);
		}
	}
	
}

























