// Make-Games.ru [Constructor, ]
// Ver 0.0.1

//** Layer
function MGELayer() {
	var Self = this;
	
	//**
	Self.IDIdScene = -1;
	
	//**
	Self.ZIndex = 0;
	
	//**
	Self.ObjectsCount = 0;
	Self.Objects = [];
	
	//** Renderer
	Self.Renderer = null;
	
	//**
	Self.Enable = true;
	Self.Visible = true;
	
	//** AABB
	Self.MinVector = [0.0, 0.0];
	Self.MaxVector = [0.0, 0.0];
	
	//**
	Self.CollisionCount = 0;
	Self.Collisions = [];
	
	//**
	Self.AddCollisionType = function (_mge_Collision_type) {
		Self.Collisions[Self.CollisionCount] = _mge_Collision_type;
		Self.CollisionCount += 1;
	}
	
	Self.DelCollisionType = function (_mge_Collision_type) {
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			if (Self.Collisions[i] === _mge_Collision_type) {
				Self.CollisionCount -= 1;
				if (i < Self.CollisionCount) {
					Self.Collisions[i] = Self.Collisions[Self.CollisionCount];
				}
				Self.Collisions[Self.CollisionCount] = null;
				return;
			}
		}
	}
	
	//** Add/Del objects
	Self.ObjectAdd = function (_mge_object) {
		Self.Objects[Self.ObjectsCount] = _mge_object;
		_mge_object.IDInLayer = Self.ObjectsCount;
		Self.ObjectsCount += 1;
	}
	
	Self.ObjectDel = function (_mge_object_id) {
		if (_mge_object_id < 0 || _mge_object_id >= Self.ObjectsCount) { return; }
		Self.ObjectsCount -= 1;
		if (_mge_object_id !== Self.ObjectsCount) {
			Self.Objects[Self.ObjectsCount].IDInLayer = Self.Objects[_mge_object_id].IDInLayer;
			Self.Objects[_mge_object_id].IDInLayer = -1;
			Self.Objects[_mge_object_id].LayerID = -1;
			Self.Objects[_mge_object_id] = Self.Objects[Self.ObjectsCount];
		}
		Self.Objects[Self.ObjectsCount] = null;
		//+USE_LENGTH+//Self.Objects.length = Self.ObjectsCount;
	}
	
	//**
	Self.Draw = function () {
		if ((Self.Renderer === null) || (Self.Visible === false) || (Self.Enable === false)) { return; }
		if (CurCamera !== null) {
			if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, CurCamera.MinVector, CurCamera.MaxVector) === false) { return; }
		}
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDrawEvent(Self.Objects[i], Self.Renderer);
		}
	}
	
	Self.MouseCollisionStep = function (_mge_mouse_pos) {
		if (CurCamera !== null) {
			if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, CurCamera.MinVector, CurCamera.MaxVector) === false) { 
				Self.ClearMouseEnter();
				return;
			}
		}
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].MouseCollisionStep(_mge_mouse_pos);
		}
	}
	
	Self.MouseClickStep = function (_mge_mouse_pos) {
		if (CurCamera !== null) {
			if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, CurCamera.MinVector, CurCamera.MaxVector) === false) { 
				Self.ClearMouseEnter();
				return;
			}
		}
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].MouseClickStep(_mge_mouse_pos);
		}
	}
	
	Self.DrawLayerCollisionMask = function () {
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			Self.Renderer.DrawCollisionMask(Self.Collisions[i].CollisionType, Self.Collisions[i].CollisionVec1, Self.Collisions[i].CollisionVec2, Self.Collisions[i].CollisionVec3, Self.Collisions[i].CollisionVec4);
		}
	}
	
	Self.DrawObjectsCollisionMask = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].DrawCollisionMask(Self.Renderer);
		}
	}
	
	
	//** collision layer - with - object, collision type
	Self.TestLayerCollisionWithObject = function (_mge_object) {
		var _colltype;
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_object.MinVector, _mge_object.MaxVector) === false) { return false; }
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (_mge_object.TestCollisionWithCollisionType(_colltype.CollisionType, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestLayerCollisionWithCollisionType = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.CollTypevsCollType(_colltype.CollisionType, _mge_collision_type, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return true; }
		}
		return false;
	}
	
	Self.TestLayerCollisionWithCollisionTypeAABB = function (_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_min_vec, _mge_max_vec) === false) { return false; }
		return Self.TestCollisionWithCollisionType(_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4);
	}
	
	Self.TestLayerCollisionWithAABB = function (_mge_vec1, _mge_vec2) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.AABBvsCollType(_colltype.CollisionType, _mge_vec1, _mge_vec2, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
		
	}
	
	Self.TestLayerCollisionWithBox = function (_mge_vec1, _mge_vec2) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.BoxvsCollType(_colltype.CollisionType, _mge_vec1, _mge_vec2, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
	}
	
	Self.TestLayerCollisionWithPoint = function (_mge_vec1) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.PointvsCollType(_colltype.CollisionType, _mge_vec1, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
	}
	
	Self.TestLayerCollisionWithLine = function (_mge_vec1, _mge_vec2) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.LinevsCollType(_colltype.CollisionType, _mge_vec1, _mge_vec2, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
	}
	
	Self.TestLayerCollisionWithSphere = function (_mge_vec1, _mge_vec2) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.SpherevsCollType(_colltype.CollisionType, _mge_vec1, _mge_vec2, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
	}
	
	Self.TestLayerCollisionWithTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.TrianglevsCollType(_colltype.CollisionType, _mge_vec1, _mge_vec2, _mge_vec3, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
	}
	
	Self.TestLayerCollisionWithTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		var _colltype;
		for ( var i = Self.CollisionCount - 1; i >= 0; i--) {
			_colltype = Self.Collisions[i];
			if (Math2D.TetragonvsCollType(_colltype.CollisionType, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4, _colltype.CollisionVec1, _colltype.CollisionVec2, _colltype.CollisionVec3, _colltype.CollisionVec4) === true) { return true; }
		}
		return false;
	}
	
//** Collision Scene Objects - with - object, collision type
	Self.TestObjectsCollisionWithObject = function (_mge_object) {
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_object.MinVector, _mge_object.MaxVector) === false) { return false; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithObject(_mge_object) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithCollisionType = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithCollisionType(_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithCollisionTypeAABB = function (_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_min_vec, _mge_max_vec) === false) { return false; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithCollisionTypeAABB(_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithAABB = function (_mge_vec1, _mge_vec2) {
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, _mge_vec1, _mge_vec2) === false) { return false; }
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithAABB( _mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithBox = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithBox(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithPoint = function (_mge_vec1) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithPoint(_mge_vec1) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithLine = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithLine(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithSphere = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithSphere(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithTriangle(_mge_vec1, _mge_vec2, _mge_vec3) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			if (Self.Objects[i].TestCollisionWithTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return true; }
		}
		return false;
	}
	
	//** Objects Event
	Self.SendCreateEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcCreateEvent(Self.Objects[i]);
		}
	}
	
	Self.SendDestroyEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDestroyEvent(Self.Objects[i]);
		}
	}
	
	Self.SendDrawEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDrawEvent(Self.Objects[i], Self.Renderer);
		}
	}
	
	Self.SendBeginStepEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcBeginStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendStepEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendEndStepEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcEndStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendCollisionEvent = function (_mge_other) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcCollisionEvent(Self.Objects[i], _mge_other);
		}
	}
	
	Self.SendUserEvent = function (_mge_event_num, _mge_event_param) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcUserEvent(Self.Objects[i], _mge_event_num, _mge_event_param);
		}
	}
	
	Self.SendMouseEnterEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseEnterEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseLeaveEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseLeaveEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseClickEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseClickEvent(Self.Objects[i]);
		}
	}
	
	//** Clear mouse Enter
	Self.ClearMouseEnter = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].MouseEnter = false;
		}
	}
	
	//**
	Self.Clear = function () {
		Self.IDIdScene = -1;
		Self.ZIndex = 0;
		Self.ObjectsCount = 0;
		//+USE_NEW_ARRAY+//Self.Objects = [];
		//+USE_LENGTH+//Self.Objects.length = 0;
		//** Renderer
		Self.Renderer = null;
		Self.Enable = true;
		Self.Visible = true;
		//** AABB
		Self.MinVector[0] = 0.0;
		Self.MinVector[1] = 0.0;
		Self.MaxVector[0] = 0.0;
		Self.MaxVector[1] = 0.0;
		//**
		Self.CollisionCount = 0;
		//+USE_NEW_ARRAY+//Self.Collisions = [];
		//+USE_LENGTH+//Self.Collisions.length = 0;
	}
	
	//** Free object
	Self.Free = function () {
		Self.Objects = null;
		Self.Renderer = null;
		Self.MinVector = null;
		Self.MaxVector = null;
		Self.Collisions = null;
	}
}

//** Scene
function MGEScene() {
	var Self = this;
	
	//** Global Objects
	Self.GlobalObjectsCount = 0;
	Self.GlobalObjects = [];
	
	//** Objects
	Self.ObjectsCount = 0;
	Self.Objects = [];
	
	//** Layers
	Self.LayersCount = 0;
	Self.Layers = [];
	
	//** Renderer
	Self.Renderer = null;
	
	//**
	Self.Size = [0.0, 0.0];
	
	//** Del all objects with out del in layer
	Self._ObjectDel = function (_mge_object_id) {
		var _obj;
		if ((_mge_object_id < 0) || (_mge_object_id >= Self.ObjectsCount)) { return; }
		_obj = Self.Objects[_mge_object_id];
		_obj.ProcDestroyEvent();
		Self.ObjectsCount -= 1;
		if (_mge_object_id !== Self.ObjectsCount) {
			Self.Objects[Self.ObjectsCount].IDInScene = _obj.IDInScene;
			Self.Objects[_mge_object_id] = Self.Objects[Self.ObjectsCount];
		}
		Self.Objects[Self.ObjectsCount] = null;
		_obj.IDInScene = -1;
		_obj.LayerID = -1;
		_obj.IDInLayer = -1;
		_obj.Parent.ObjectDel(_obj.IDInParent);
		_obj = null;
		//+USE_LENGTH+//Self.Objects.length = Self.ObjectsCount;
	}

	//**
	Self.Initialize = function (_mge_renderer, _mge_size) {
		Self.GlobalObjectsCount = 0;
		Self.ObjectsCount = 0;
		Self.LayersCount = 0;
		Self.Renderer = _mge_renderer;
		Self.Size[0] = _mge_size[0];
		Self.Size[1] = _mge_size[1];
	}
	
	//** Layers
	Self.LayerAdd = function (_mge_z_index, _mge_renderer) {
		var _layer;
		_layer = new MGELayer();
		Self.Layers[Self.LayersCount] = _layer;
		_layer.IDInScene = Self.LayersCount;
		if (_mge_renderer === null) {
			_layer.Renderer = Self.Renderer;
		} else {
			_layer.Renderer = _mge_renderer;
		}
		Self.LayersCount += 1;
		_layer.MaxVector[0] = Self.Size[0];
		_layer.MaxVector[1] = Self.Size[1];
		return _layer;
	}

	Self.LayerDel = function (_mge_layer_id) {
		var _layer;
		if ((_mge_layer_id < 0) || (_mge_layer_id >= Self.LayersCount)) { return; }	
		_layer = Self.Layers[_mge_layer_id];
		for ( var i = _layer.ObjectsCount - 1; i >= 0; i--) {
			Self._ObjectDel(_layer.Objects[i].IDInScene);
		}
		_layer.IDInScene = -1;
		//+USE_FREE+//_layer.Free();
		Self.LayersCount -= 1;
		if (_mge_layer_id !== Self.LayersCount) {
			for ( var i = _mge_layer_id; i < Self.LayersCount; i++) {
				Self.Layers[i] = Self.Layers[i + 1];
				Self.Layers[i].IDInScene = i;
			}
		}
		Self.Layers[Self.LayersCount] = null;
		_layer = null;
		//+USE_LENGTH+//Self.Layers.length = Self.LayersCount;
	}
	
	Self.LayersSort = function () {
		//
	}
	
	//** Global objects
	Self.GlobalObjectAdd = function (_mge_global_object) {
		Self.GlobalObjects[Self.GlobalObjectsCount] = _mge_global_object;
		_mge_global_object.Scene = Self;
		_mge_global_object.IDInScene = Self.GlobalObjectsCount;
		Self.GlobalObjectsCount += 1;
	}

	Self.GlobalObjectDel = function (_mge_global_object_id) {
		if ((_mge_global_object_id < 0) || (_mge_global_object_id >= Self.GlobalObjectsCount)) { return; }
		Self.GlobalObjects[_mge_global_object_id].Scene = null;
		Self.GlobalObjects[_mge_global_object_id].IDInScene = -1;
		Self.GlobalObjectsCount -= 1;
		if (_mge_global_object_id !== Self.GlobalObjectsCount) {
			for ( var i = _mge_global_object_id; i < Self.GlobalObjectsCount; i++) {
				Self.GlobalObjects[i] = Self.GlobalObjects[i + 1];
				Self.GlobalObjects[i].IDInScene = i;
			}
		}
		Self.GlobalObjects[Self.GlobalObjectsCount] = null;
		//+USE_LENGTH+//Self.GlobalObjects.length = Self.GlobalObjectsCount;
	}

	//** Objects
	Self.ObjectAdd = function (_mge_layer_id, _mge_global_object) {
		var _obj, _layer;
		if (_mge_global_object.Scene != Self) { return; }
		if ((_mge_layer_id < 0) || (_mge_layer_id >= Self.LayersCount) || (Self.LayersCount === 0)) { return; }
		_obj = _mge_global_object.ObjectAdd();
		_obj.IDInScene = Self.ObjectsCount;
		Self.Objects[Self.ObjectsCount] = _obj;
		Self.ObjectsCount += 1;
		_obj.LayerID = _mge_layer_id;
		Self.Layers[_mge_layer_id].ObjectAdd(_obj);
		_obj.ProcCreateEvent();
		return _obj;
	}

	Self.ObjectDel = function (_mge_object_id) {
		var _obj;
		if ((_mge_object_id < 0) || (_mge_object_id >= Self.ObjectsCount)) { return; }
		_obj = Self.Objects[_mge_object_id];
		_obj.ProcDestroyEvent();
		Self.Layers[_obj.LayerID].ObjectDel(_obj.IDInLayer);
		Self.ObjectsCount -= 1;
		if (_mge_object_id !== Self.ObjectsCount) {
			Self.Objects[Self.ObjectsCount].IDInScene = _obj.IDInScene;
			Self.Objects[_mge_object_id] = Self.Objects[Self.ObjectsCount];
		}
		Self.Objects[Self.ObjectsCount] = null;
		_obj.IDInScene = -1;
		_obj.Parent.ObjectDel(_obj.IDInParent);
		_obj = null;
		//+USE_LENGTH+//Self.Objects.length = Self.ObjectsCount;
	}
	
	//** Objects Event
	Self.SendCreateEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcCreateEvent(Self.Objects[i]);
		}
	}
	
	Self.SendDestroyEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDestroyEvent(Self.Objects[i]);
		}
	}
	
	Self.SendDrawEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcDrawEvent(Self.Objects[i], Self.Renderer);
		}
	}
	
	Self.SendBeginStepEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcBeginStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendStepEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendEndStepEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcEndStepEvent(Self.Objects[i]);
		}
	}
	
	Self.SendCollisionEvent = function (_mge_other) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcCollisionEvent(Self.Objects[i], _mge_other);
		}
	}
	
	Self.SendUserEvent = function (_mge_event_num, _mge_event_param) {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcUserEvent(Self.Objects[i], _mge_event_num, _mge_event_param);
		}
	}
	
	Self.SendMouseEnterEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseEnterEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseLeaveEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseLeaveEvent(Self.Objects[i]);
		}
	}
	
	Self.SendMouseClickEvent = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcMouseClickEvent(Self.Objects[i]);
		}
	}
	
	//** Scene public func for step
	Self.BeginStep = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcBeginStepEvent(Self.Objects[i]);
		}
	}
	
	Self.Step = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcStepEvent(Self.Objects[i]);
		}
	}
	
	Self.EndStep = function () {
		for ( var i = Self.ObjectsCount - 1; i >= 0; i--) {
			Self.Objects[i].ProcEndStepEvent(Self.Objects[i]);
		}
	}
	
	Self.CollisionStep = function () {
		for ( var i = Self.GlobalObjectsCount - 1; i >= 0; i--) {
			Self.GlobalObjects[i].CollisionStep();
		}
	}
	
	Self.MouseCollisionStep = function (_mge_mouse_pos) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			Self.Layers[i].MouseCollisionStep(_mge_mouse_pos);
		}
	}
	
	Self.MouseClickStep = function (_mge_mouse_pos) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			Self.Layers[i].MouseClickStep(_mge_mouse_pos);
		}
	}
	
	Self.CollisionClear = function () {
		for ( var i = Self.GlobalObjectsCount - 1; i >= 0; i--) {
			Self.GlobalObjects[i].CollisionClear(Self.Objects[i]);
		}
	}

	Self.Draw = function () {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			Self.Layers[i].Draw();
		}
	}
	
	Self.DrawSceneCollisionMask = function () {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			Self.Layers[i].DrawLayerCollisionMask();
		}
	}
	
	Self.DrawObjectsCollisionMask = function () {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			Self.Layers[i].DrawObjectsCollisionMask();
		}
	}
	
	//** Collision Scene Layers - with - object, collision type
	Self.TestSceneCollisionWithObject = function (_mge_object) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithObject(_mge_object) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestSceneCollisionWithCollisionType = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithCollisionType(_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestSceneCollisionWithCollisionTypeAABB = function (_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithCollisionTypeAABB(_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestSceneCollisionWithAABB = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithAABB( _mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestSceneCollisionWithBox = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithBox(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestSceneCollisionWithPoint = function (_mge_vec1) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithPoint(_mge_vec1) === true) { return true; }
		}
		return false;
	}
	
	Self.TestSceneCollisionWithLine = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithLine(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestSceneCollisionWithSphere = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithSphere(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestSceneCollisionWithTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithTriangle(_mge_vec1, _mge_vec2, _mge_vec3) === true) { return true; }
		}
		return false;
	}
	
	Self.TestSceneCollisionWithTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestLayerCollisionWithTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return true; }
		}
		return false;
	}
	
	//** Collision Scene Objects - with - object, collision type
	Self.TestObjectsCollisionWithObject = function (_mge_object) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithObject(_mge_object) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithCollisionType = function (_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithCollisionType(_mge_collision_type, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithCollisionTypeAABB = function (_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithCollisionTypeAABB(_mge_collision_type, _mge_min_vec, _mge_max_vec, _mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) {
				return true;
			}
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithAABB = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithAABB( _mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithBox = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithBox(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithPoint = function (_mge_vec1) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithPoint(_mge_vec1) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithLine = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithLine(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithSphere = function (_mge_vec1, _mge_vec2) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithSphere(_mge_vec1, _mge_vec2) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithTriangle = function (_mge_vec1, _mge_vec2, _mge_vec3) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithTriangle(_mge_vec1, _mge_vec2, _mge_vec3) === true) { return true; }
		}
		return false;
	}
	
	Self.TestObjectsCollisionWithTetragon = function (_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			if (Self.Layers[i].TestObjectsCollisionWithTetragon(_mge_vec1, _mge_vec2, _mge_vec3, _mge_vec4) === true) { return true; }
		}
		return false;
	}
	
	//** Clear mouse Enter
	Self.ClearMouseEnter = function () {
		for ( var i = Self.LayersCount - 1; i >= 0; i--) {
			Self.Layers[i].ClearMouseEnter();
		}
	}
	
	//**
	Self.Clear = function () {
		//** Global Objects
		Self.GlobalObjectsCount = 0;
		//+USE_NEW_ARRAY+//Self.GlobalObjects = [];
		//+USE_LENGTH+//Self.GlobalObjects.length = 0;
		//** Objects
		Self.ObjectsCount = 0;
		//+USE_NEW_ARRAY+//Self.Objects = [];
		//+USE_LENGTH+//Self.Objects.length = 0;
		//** Layers
		Self.LayersCount = 0;
		//+USE_NEW_ARRAY+//Self.Layers = [];
		//+USE_LENGTH+//Self.Layers.length = 0;
		//** Renderer
		Self.Renderer = null;
		Self.Size[0] = _mge_size[0];
		Self.Size[1] = _mge_size[1];
	}
	
	//**
	Self.Free = function () {
		Self.Renderer = null;
		Self.GlobalObjects = null;
		Self.Objects = null;
		Self.Layers = null;
		Self.Size = null;
	}
}



















