// Make-Games.ru [Constructor, ]
// Ver 0.0.1

var SoundTypeMP3   = 0;
var SoundTypeOGG   = 1;
var SoundTypeOGA   = 2;
var SoundTypeWEBMA = 3;
var SoundTypeWAV   = 4;

// sound types for loading
var SoundExt = new Array(5);
var SoundType = new Array(5);
SoundExt [0] = ".mp3";
SoundType[0] = "audio/mpeg";
SoundExt [1] = ".ogg";
SoundType[1] = "audio/ogg";
SoundExt [2] = ".oga";
SoundType[2] = "audio/ogg";
SoundExt [3] = ".webma";
SoundType[3] = "audio/webm";
SoundExt [4] = ".wav";
SoundType[4] = "audio/wav";
 

function MGESoundManager() {
	var Self = this;

	//** sound buffers
	Self.SoundCount = 0;
	Self.SoundChannel = [];

	//** get message, if all sound loaded
	Self.SoundLoadCount = 0;
	Self.SoundLoadCur = 0;
	Self.ProcSoundEvent = function (_mge_current, _mge_count) { }

	//**
	Self._SoundLoadEvent = function () {
		Self.SoundLoadCur += 1;
		Self.ProcSoundEvent(Self.SoundLoadCur, Self.SoundLoadCount);
		if (Self.SoundLoadCur >= Self.SoundLoadCount) { 
			Self.SoundLoadCur = 0;
			Self.SoundLoadCount = 0;
		}
	}
	
	//**
	Self.SetLoadCount = function (_mge_sound_count, _mge_sound_user_event) {
		Self.SoundLoadCount = _mge_sound_count;
		Self.ProcSoundEvent = _mge_sound_user_event;
		Self.SoundLoadCur = 0;
	}

	Self.Load = function (_mge_sound_types, _mge_sound_path) {
		var _SoundLength = _mge_sound_types.length;
		var _Sources;

		Self.SoundChannel[Self.SoundCount] = document.createElement('audio');
		Self.SoundChannel[Self.SoundCount].preload = 'auto';
		
		//cocoonJS Self.SoundChannel[Self.SoundCount].src = _mge_sound_path + SoundExt[_mge_sound_types[0]];
		
		for ( var i = 0; i < _SoundLength; i++) {
			_Sources = document.createElement('source');
			_Sources.src = _mge_sound_path + SoundExt[_mge_sound_types[i]];
			_Sources.type = SoundType[_mge_sound_types[i]];
			Self.SoundChannel[Self.SoundCount].appendChild( _Sources );
			_Sources = null;
		}

		Self.SoundChannel[Self.SoundCount].addEventListener("canplaytrough", Self._SoundLoadEvent);
		Self.SoundChannel[Self.SoundCount].addEventListener("ended", function (_mge_event) {
			if (this.PlayLoop === true) {
				this.currentTime = 0;
				this.play();
			}
		});
		Self.SoundChannel[Self.SoundCount].load();
		
		Self.SoundCount += 1;
		return Self.SoundCount;
	}

	Self.Play = function (_mge_sound_id, _mge_play_loop) {
		Self.SoundChannel[_mge_sound_id-1].PlayLoop = _mge_play_loop;
		Self.SoundChannel[_mge_sound_id-1].currentTime = 0;
		Self.SoundChannel[_mge_sound_id-1].play();
	}

	Self.Pause = function (_mge_sound_id) {
		Self.SoundChannel[_mge_sound_id-1].pause();
	}

	Self.Resume = function (_mge_sound_id) {
		Self.SoundChannel[_mge_sound_id-1].play();
	}

	Self.Stop = function (_mge_sound_id) {
		Self.SoundChannel[_mge_sound_id-1].currentTime = 0;
		Self.SoundChannel[_mge_sound_id-1].pause();
	}
	
	Self.SetVolume = function (_mge_sound_id, _mge_sound_volume) {
		Self.SoundChannel[_mge_sound_id-1].volume = _mge_sound_volume;
	}
	
	Self.GetVolume = function (_mge_sound_id) {
		return Self.SoundChannel[_mge_sound_id-1].volume;
	}

	Self.SetPosition = function (_mge_sound_id, _mge_sound_position) {
		Self.SoundChannel[_mge_sound_id-1].currentTime = _mge_sound_position;
		Self.SoundChannel[_mge_sound_id-1].pause();
	}

	Self.GetPosition = function (_mge_sound_id) {
		return Self.SoundChannel[_mge_sound_id-1].currentTime;
	}

	Self.GetLength = function (_mge_sound_id) {
		return Self.SoundChannel[_mge_sound_id-1].duration * 1000;
	}
	
	//** Set Global Volume
	Self.SetGlobalVolume = function (_mge_sound_volume) {
		for ( var i = Self.SoundCount - 1; i >= 0; i--) {
			Self.SoundChannel[i].volume = _mge_sound_volume;
		}
	}
	
	Self.AddGlobalVolume = function (_mge_sound_volume) {
		for ( var i = Self.SoundCount - 1; i >= 0; i--) {
			Self.SoundChannel[i].volume += _mge_sound_volume;
		}
	}
	
	Self.SubGlobalVolume = function (_mge_sound_volume) {
		for ( var i = Self.SoundCount - 1; i >= 0; i--) {
			Self.SoundChannel[i].volume -= _mge_sound_volume;
		}
	}
	
	//**
	Self.Clear = function () {
		for ( var i = Self.SoundCount - 1; i >= 0; i--) {
			Self.SoundChannel[i] = null;
		}
		//+USE_NEW_ARRAY+//Self.SoundChannel = [];
		//+USE_LENGTH+//Self.SoundChannel.length = 0
		Self.SoundCount = 0;
		//** get message, if all sound loaded
		Self.SoundLoadCount = 0;
		Self.SoundLoadCur = 0;
		Self.ProcSoundEvent = function (_mge_current, _mge_count) { }
	}
	
	//**
	Self.Free = function () {
		for ( var i = Self.SoundCount - 1; i >= 0; i--) {
			Self.SoundChannel[i] = null;
		}
		Self.SoundChannel = null;
	}
	
}


















 