// Make-Games.ru [Constructor, ]
// Ver 0.0.1

//**
var GlobalSupportWebkitAudioContext = false;
var GlobalSupportWebAudioAPI = false;
if (typeof AudioContext !== "undefined") {
	GlobalSupportWebkitAudioContext = false;
	GlobalSupportWebAudioAPI = true;
} else {
	if (typeof webkitAudioContext !== "undefined") {
		GlobalSupportWebkitAudioContext = true;
		GlobalSupportWebAudioAPI = true;
	}
}

//alert(GlobalSupportWebkitAudioContext);
//alert(GlobalSupportWebAudioAPI);

function MGESoundExBuffer() {
	var Self = this;
	
	//**
	Self.IDInParent = -1;
	Self.Parent = null;
	Self.Buffer = null;
}

function MGESoundExSource() {
	var Self = this;
	
	//**
	Self.IDInParent = -1;
	Self.Parent = null;
	Self.Buffer = null;
	Self.Sources = null;
	Self.Gain = null;
	Self.PlayTime = 0;
	Self.IsPause = false;
	
	//**
	/*if (GlobalSupportWebkitAudioContext === true) {*/
		Self.Play = function (_mge_loop, _mge_clear_prev) {
			if (_mge_clear_prev === true) {
				if (Self.Gain !== null) { Self.Gain.disconnect(0); }
				if (Self.Sources !== null) { Self.Sources.disconnect(0); }
			}
			//
			Self.Sources = Self.Parent.Context.createBufferSource();
			Self.Sources.connect(Self.Parent.Context.destination);
			Self.Sources.buffer = Self.Buffer;
			//
			Self.Gain = Self.Parent.Context.createGain(); //createGainNode
			Self.Sources.connect(Self.Gain);
			Self.Gain.connect(Self.Parent.Context.destination);
			//
			Self.Sources.loop = _mge_loop;
			if (Self.IsPause === false) {
				Self.Sources.start(0); //noteOn
			} else {
				//alert("Pause === true");
				if (Self.PlayTime > 0) {
					Self.Sources.start(0, Self.PlayTime / 1000); //noteGrainOn
				} else {
					Self.Sources.start(0); //noteOn
				}
			}
			Self.PlayTime = new Date().getTime();
			Self.IsPause = false;
		}
		Self.Stop = function () {
			Self.Sources.noteOff(0); //noteOff
			Self.PlayTime = 0;
			Self.IsPause = false;
		}
		Self.Pause = function () {
			Self.Sources.stop(0); //noteOff
			Self.PlayTime = new Date().getTime() - Self.PlayTime;
			Self.IsPause = true;
		}
		//**
		Self.SetVolume = function (_mge_volume) {
			Self.Gain.gain.value = _mge_volume;
		}
		Self.AddVolume = function (_mge_volume) {
			Self.Gain.gain.value += _mge_volume;
		}
		Self.SubVolume = function (_mge_volume) {
			Self.Gain.gain.value -= _mge_volume;
		}
		//**
		Self.SetSoundSpeed = function (_mge_speed) {
			Self.Sources.playbackRate.value = _mge_speed;
		}
		Self.Clear = function () {
			Self.Gain.disconnect(0);
			Self.Sources.disconnect(0);
		}
	/*} else {

	}*/
}

function MGESoundManagerEx() {
	var Self = this;
	if (GlobalSupportWebAudioAPI === false) { return; }
	
	//**
	Self.Context = null;
	
	//**
	Self.BuffersCount = 0;
	Self.Buffers = [];
	
	//**
	Self.SourcesCount = 0;
	Self.Sources = [];
	
	//** get message, if all sound loaded
	Self.SoundLoadCount = 0;
	Self.SoundLoadCur = 0;
	Self.ProcSoundEvent = function (_mge_current, _mge_count) {  }
	
	//**
	Self._SoundLoadEvent = function () {
		//alert("_SoundLoadEvent");
		Self.SoundLoadCur += 1;
		Self.ProcSoundEvent(Self.SoundLoadCur, Self.SoundLoadCount);
		if (Self.SoundLoadCur >= Self.SoundLoadCount) { 
			Self.SoundLoadCur = 0;
			Self.SoundLoadCount = 0;
		}
	}
	
	//**
	if (GlobalSupportWebkitAudioContext === true) {
		Self.Initialize = function () {
			Self.Context = new webkitAudioContext();
			Self.SoundLoadCount = 0;
			Self.SoundLoadCur = 0;
			//alert("webkitAudioContext");
		}
	} else {
		Self.Initialize = function () {
			Self.Context = new AudioContext();
			Self.SoundLoadCount = 0;
			Self.SoundLoadCur = 0;
			//alert("AudioContext");
		}
	}
	
	//**
	Self.SetLoadCount = function (_mge_sound_count, _mge_sound_user_event) {
		Self.SoundLoadCount = _mge_sound_count;
		Self.ProcSoundEvent = _mge_sound_user_event;
		Self.SoundLoadCur = 0;
	}
	
	Self.AddBuffer = function (_mge_byte_file_array) {
		var _buffer = new MGESoundExBuffer();
		Self.Context.decodeAudioData(_mge_byte_file_array, function(_mge_buffer) {
			Self.Buffers[Self.BuffersCount] = _buffer;
			_buffer.IDInParent = Self.BuffersCount;
			_buffer.Parent = Self;
			_buffer.Buffer = _mge_buffer;
			Self.BuffersCount += 1;
			Self._SoundLoadEvent();
			//alert("decodeAudioData");
		}, function(e) {
			alert('MGESoundEx.LoadFromBuffer.decodeAudioData : Error');
		});
		return _buffer;
	}
	
	Self.DelBuffer = function (_mge_buffer_id) {
		var _buf;
		if ((_mge_buffer_id < 0) || (_mge_buffer_id >= Self.BuffersCount)) { return; }
		_buf = Self.Buffers[_mge_buffer_id];
		Self.BuffersCount -= 1;
		if (_mge_object_id !== Self.BuffersCount) {
			Self.Buffers[Self.BuffersCount].IDInParent = _mge_object_id;
			Self.Buffers[_mge_object_id] = Self.Buffers[Self.BuffersCount];
		}
		_buf.Parent = null;
		_buf.Buffer = null;
		_buf = null;
		//+USE_LENGTH+//Self.Buffers.length = Self.BuffersCount;
	}
	
	Self.ClearBuffers = function () {
		for ( var i = Self.BuffersCount - 1; i >= 0; i--) {
			Self.Buffers[i].Parent = null;
			Self.Buffers[i].Buffer = null;
			Self.Buffers[i].IDInParent  = -1;
			Self.Buffers[i] = null;
		}
		Self.BuffersCount = 0;
		//+USE_LENGTH+//Self.Buffers.length = Self.BuffersCount;
	}
	
	//**
	Self.AddSource = function (_mge_buffer_id) {
		var _source;
		if ((_mge_buffer_id < 0) || (_mge_buffer_id >= Self.BuffersCount)) { return; }
		//alert(Self.Buffers[_mge_buffer_id].Buffer);
		_source = new MGESoundExSource();
		Self.Sources[Self.SourcesCount] = _source;
		_source.IDInParent = Self.SourcesCount;
		_source.Parent = Self;
		_source.Buffer = Self.Buffers[_mge_buffer_id].Buffer;
		Self.SourcesCount += 1;
		return _source;

	}
	
	Self.DelSource = function (_mge_source_id) {
		var _source;
		if ((_mge_source_id < 0) || (_mge_source_id >= Self.SourcesCount)) { return; }
		_source = Self.Buffers[_mge_source_id];
		Self.BuffersCount -= 1;
		if (_mge_object_id !== Self.SourcesCount) {
			Self.Sources[Self.SourcesCount].IDInParent = _mge_object_id;
			Self.Sources[_mge_object_id] = Self.Buffers[Self.SourcesCount];
		}
		_source.Parent = null;
		_source.Buffer = null;
		_source.Sources = null;
		_source.Gain = null;
		_source = null;
		//+USE_LENGTH+//Self.Sources.length = Self.SourcesCount;
	}
	
	Self.ClearSources = function () {
		for ( var i = Self.SourcesCount - 1; i >= 0; i--) {
			Self.Sources[i].Parent = null;
			Self.Sources[i].Buffer = null;
			Self.Sources[i].IDInParent  = -1;
			Self.Sources[i].Sources = null;
			Self.Sources[i].Gain = null;
			Self.Sources[i] = null;
		}
		Self.BuffersCount = 0;
		//+USE_LENGTH+//Self.Buffers.length = Self.BuffersCount;
	}
	
	//**
	Self.SetGlobalVolume = function (_mge_sound_volume) {
		for ( var i = Self.SourcesCount - 1; i >= 0; i--) {
			Self.Sources[i].SetVolume(_mge_sound_volume);
		}
	}
	
	Self.AddGlobalVolume = function (_mge_sound_volume) {
		for ( var i = Self.SourcesCount - 1; i >= 0; i--) {
			Self.Sources[i].AddVolume(_mge_sound_volume);
		}
	}
	
	Self.SubGlobalVolume = function (_mge_sound_volume) {
		for ( var i = Self.SourcesCount - 1; i >= 0; i--) {
			Self.Sources[i].SubVolume(_mge_sound_volume);
		}
	}
	
	//**
	Self.Clear = function () {
		for ( var i = Self.SourcesCount - 1; i >= 0; i--) {
			Self.Sources[i].Clear();
		}
		Self.Context = null;
		//**
		Self.BuffersCount = 0;
		//+USE_NEW_ARRAY+//Self.Buffers = [];
		//+USE_LENGTH+//Self.Buffers.length = 0
		//**
		Self.SourcesCount = 0;
		//+USE_NEW_ARRAY+//Self.Sources = [];
		//+USE_LENGTH+//Self.Sources.length = 0
		//** get message, if all sound loaded
		Self.SoundLoadCount = 0;
		Self.SoundLoadCur = 0;
		Self.ProcSoundEvent = function (_mge_current, _mge_count) {  }
	}
	
	//**
	Self.Free = function () {
		Self.Context = null;
		Self.Buffers = null;
		Self.Sources = null;
	}
}
























