// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGESprite() {
	var Self = this;
	//**
	Self.Image = null;
	Self.Width = 0;
	Self.Height = 0;
	Self.FramesCount_X = 0;
	Self.FramesCount_Y = 0;
	Self.FramesCurrent = 0;
	Self.FramesCurrent_X = 0;
	Self.FramesCurrent_Y = 0;
	Self.FramesWidth = 0;
	Self.FramesHeight = 0;
	Self.SourcesPosition = [0, 0];
	Self.SourcesSize = [0, 0];
	Self.FramesCount = 0;
	//** Animation
	Self.Speed = 0;
	Self.CurrentFrame = 0;
	Self.Size = [0, 0];

	//**
	Self.Initialize = function (_mge_image, _mge_frames_count_x, _mge_frames_count_y, _mge_frames_count) {
		Self.Image = _mge_image;
		Self.Width = Self.Image.width;
		Self.Height = Self.Image.height;
		Self.SetFramesCount(_mge_frames_count_x, _mge_frames_count_y, _mge_frames_count);
		Self.Speed = 0;
		Self.CurrentFrame = 0;
		Self.Size[0] = Self.Width;
		Self.Size[1] = Self.Height;
	}

	//**
	Self.SetFramesCount = function (_mge_frames_count_x, _mge_frames_count_y, _mge_frames_count) {
		Self.Width = Self.Image.width;
		Self.Height = Self.Image.height;
		Self.FramesCount_X = _mge_frames_count_x;
		Self.FramesCount_Y = _mge_frames_count_y;
		Self.FramesWidth  = Math.round(Self.Width / Self.FramesCount_X);
		Self.FramesHeight = Math.round(Self.Height / Self.FramesCount_Y);
		Self.SourcesSize[0] = Self.FramesWidth;
		Self.SourcesSize[1] = Self.FramesHeight;
		Self.SourcesPosition[0] = 0;
		Self.SourcesPosition[1] = 0;
		Self.FramesCurrent_X = 0;
		Self.FramesCurrent_Y = 0;
		Self.FramesCurrent = 0;
		Self.FramesCount = _mge_frames_count;
	}

	Self.SetCurrentFrame = function (_mge_frames_cur) {
		if ((_mge_frames_cur >= Self.FramesCount) || (_mge_frames_cur === 0)) { 
			Self.FramesCurrent = 0;
			Self.FramesCurrent_X = 0;
			Self.FramesCurrent_Y = 0;
			Self.SourcesPosition[0] = 0;
			Self.SourcesPosition[1] = 0;
		} else {
			Self.FramesCurrent = _mge_frames_cur;
			Self.FramesCurrent_Y = Math.floor(_mge_frames_cur / Self.FramesCount_X);
			Self.FramesCurrent_X = _mge_frames_cur - (Self.FramesCurrent_Y * Self.FramesCount_X);
			Self.SourcesPosition[0] = Self.FramesCurrent_X * Self.FramesWidth;
			Self.SourcesPosition[1] = Self.FramesCurrent_Y * Self.FramesHeight;
		}
	}

	Self.NextFrame = function () {
		Self.SetCurrentFrame(Self.FramesCurrent + 1);
	}
	
	//**
	Self.Step = function () {
		if (Self.Speed === 0) { return; }
		Self.CurrentFrame += 1;
		if (Self.CurrentFrame >= Self.Speed) {
			Self.CurrentFrame = 0;
			Self.NextFrame();
		}
	}
	
	//**
	Self.Clear = function () {
		Self.Image = null;
		Self.Width = 0;
		Self.Height = 0;
		Self.FramesCount_X = 0;
		Self.FramesCount_Y = 0;
		Self.FramesCurrent = 0;
		Self.FramesCurrent_X = 0;
		Self.FramesCurrent_Y = 0;
		Self.FramesWidth = 0;
		Self.FramesHeight = 0;
		Self.SourcesPosition[0] = 0;
		Self.SourcesPosition[1] = 0;
		Self.SourcesSize[0] = 0;
		Self.SourcesSize[1] = 0;
		Self.FramesCount = 0;
		//** Animation
		Self.Speed = 0;
		Self.CurrentFrame = 0;
		Self.Size[0] = 0;
		Self.Size[1] = 0;
	}

	//**
	Self.Free = function () {
		Self.Image = null;
		Self.SourcesPosition = null;
		Self.SourcesSize = null;
		Self.Size = null;
	}

}



















