// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGETilesChunk() {
	var Self = this;
	
	//**
	Self.Parent = null;
	Self.IDInTiles = -1;
	
	//**
	Self.Sprite = null;
	
	//**
	Self.TilesCount = 0;
	Self.Tiles_X = [];
	Self.Tiles_Y = [];
	Self.Tiles_ID_X = [];
	Self.Tiles_ID_Y = [];
	
	//**
	Self.MinVector = [0.0, 0.0];
	Self.MaxVector = [0.0, 0.0];
	
	//**
	Self.TileSize = [0.0, 0.0];
	
	//**
	Self.AddTile = function (_mge_position, _mge_id_x, _mge_id_y) {
		Self.Tiles_X[Self.TilesCount] = _mge_position[0];
		Self.Tiles_Y[Self.TilesCount] = _mge_position[1];
		Self.Tiles_ID_X[Self.TilesCount] = _mge_id_x;
		Self.Tiles_ID_Y[Self.TilesCount] = _mge_id_y;
		Self.TilesCount += 1;
	}
	
	Self.DelTile = function (_mge_id) {
		if (_mge_id < 0 || _mge_id >= Self.TilesCount) { return; }
		Self.TilesCount -= 1;
		if (_mge_id < Self.TilesCount) {
			Self.Tiles_X[_mge_id] = Self.Tiles_X[Self.TilesCount];
			Self.Tiles_Y[_mge_id] = Self.Tiles_Y[Self.TilesCount];
			Self.Tiles_ID_X[_mge_id] = Self.Tiles_ID_X[Self.TilesCount];
			Self.Tiles_ID_Y[_mge_id] = Self.Tiles_ID_Y[Self.TilesCount];
		}
	}
	
	//**
	Self.Draw = function () {
		var _pos_x, _pos_y;
		if ((Self.Parent === null) || (Self.Sprite === null)) { return; }
		if (Math2D.AABBvsAABB(Self.MinVector, Self.MaxVector, CurCamera.MinVector, CurCamera.MaxVector) === false) { return; }
		for ( var i = Self.TilesCount - 1; i >= 0; i--) {
			_pos_x = Self.TileSize[0] * Self.Tiles_ID_X[i];
			_pos_y = Self.TileSize[1] * Self.Tiles_ID_Y[i];
			Self.Parent.Renderer.DrawSpriteRect(Self.Sprite.Image, _pos_x, _pos_y, Self.TileSize[0], Self.TileSize[1], 
				Self.Tiles_X[i], Self.Tiles_Y[i], Self.TileSize[0], Self.TileSize[1]);
		}
	}
	
	//**
	Self.Clear = function () {
		Self.Parent = null;
		Self.IDInTiles = -1;
		//**
		Self.Sprite = null;
		//**
		Self.TilesCount = 0;
		//+USE_NEW_ARRAY+//Self.Tiles_X = [];
		//+USE_LENGTH+//Self.Tiles_X.length = 0;
		//+USE_NEW_ARRAY+//Self.Tiles_Y = [];
		//+USE_LENGTH+//Self.Tiles_Y.length = 0;
		//+USE_NEW_ARRAY+//Self.Tiles_ID_X = [];
		//+USE_LENGTH+//Self.Tiles_ID_X.length = 0;
		//+USE_NEW_ARRAY+//Self.Tiles_ID_Y = [];
		//+USE_LENGTH+//Self.Tiles_ID_Y.length = 0;
		//**
		Self.MinVector[0] = 0.0;
		Self.MinVector[1] = 0.0;
		Self.MaxVector[0] = 0.0;
		Self.MaxVector[1] = 0.0;
		//**
		Self.TileSize[0] = 0.0;
		Self.TileSize[1] = 0.0;
	}
	
	//**
	Self.Free = function () {
		Self.Parent = null;
		Self.Sprite = null;
		Self.Tiles_X = null;
		Self.Tiles_Y = null;
		Self.Tiles_ID_X = null;
		Self.Tiles_ID_Y = null;
		Self.MinVector = null;
		Self.MaxVector = null;
	}
	
}

function MGETiles() {
	var Self = this;
	
	//**
	Self.Sprite = null;
	
	//**
	Self.ChunksCount = 0;
	Self.Chunks = [];
	
	//**
	Self.TileSize = [0.0, 0.0];
	
	//**
	Self.Size = [0.0, 0.0];
	
	//**
	Self.Renderer = null;
	
	//**
	Self.Initialize = function (_mge_sprite, _mge_renderer, _mge_tile_size, _mge_map_size) {
		Self.Sprite = _mge_sprite;
		Self.TileSize[0] = _mge_tile_size[0];
		Self.TileSize[1] = _mge_tile_size[1];
		Self.Size[0] = _mge_map_size[0];
		Self.Size[1] = _mge_map_size[1];
		Self.Renderer = _mge_renderer;
	}
	
	//**
	Self.AddChunk = function () {
		var _chunk = new MGETilesChunk();
		_chunk.MaxVector[0] = Self.Size[0];
		_chunk.MaxVector[1] = Self.Size[1];
		_chunk.Sprite = Self.Sprite;
		_chunk.TileSize[0] = Self.TileSize[0];
		_chunk.TileSize[1] = Self.TileSize[1];
		_chunk.IDInTiles = Self.ChunksCount;
		_chunk.Parent = Self;
		Self.Chunks[Self.ChunksCount] = _chunk;
		Self.ChunksCount += 1;
		return _chunk;
	}
	
	Self.DelChunk = function (_mge_id) {
		if (_mge_id < 0 || _mge_id >= Self.ChunksCount) { return; }
		Self.ChunksCount -= 1;
		if (_mge_id < Self.ChunksCount) {
			Self.Chunks[_mge_id] = Self.Chunks[Self.ChunksCount];
		}
		Self.Chunks[Self.ChunksCount] = null;
	}
	
	//**
	Self.Draw = function () {
		if (Self.Renderer === null) { return; }
		for ( var i = Self.ChunksCount - 1; i >= 0; i--) {
			Self.Chunks[i].Draw();
		}
	}
	
	//**
	Self.Clear = function () {
		//**
		Self.Sprite = null;
		//**
		Self.ChunksCount = 0;
		//+USE_NEW_ARRAY+//Self.Chunks = [];
		//+USE_LENGTH+//Self.Chunks.length = 0;
		//**
		Self.TileSize[0] = 0.0;
		Self.TileSize[1] = 0.0;
		//**
		Self.Size[0] = 0.0;
		Self.Size[1] = 0.0;
		//**
		Self.Renderer = null;
	}
	
	//**
	Self.Free = function () {
		Self.Sprite = null;
		Self.Chunks = null;
		Self.Renderer = null;
		Self.TileSize = null;
		Self.Size = null;
		
	}
	
}




















