// Make-Games.ru [Constructor, Конструктор]
// Ver 0.0.1
// ;

var IdentityVector2F = [0.0, 0.0];
var IdentityVector2I = [0, 0];
var IdentityVector2  = [0, 0];

var IdentityVector3F = [0.0, 0.0, 0.0];
var IdentityVector3I = [0, 0, 0];
var IdentityVector3  = [0, 0, 0];

var IdentityVector4F = [0.0, 0.0, 0.0, 0.0];
var IdentityVector4I = [0, 0, 0, 0];
var IdentityVector4  = [0, 0, 0, 0];

var ColorByteToFloat = 1 / 255;

//**

var Vec = null;

function MGEVector() {
	var Self = this;
	
	Self.Min = function (_mge_a, _mge_b) {
		if (_mge_a > _mge_b) { return _mge_b; } else { return _mge_a }
	}
	
	Self.Max = function (_mge_a, _mge_b) {
		if (_mge_a > _mge_b) { return _mge_a; } else { return _mge_b }
	}
	
	//**
	Self.GetVector2 = function (_mge_x, _mge_y) {
		return [_mge_x, _mge_y];
	}

	Self.GetVector3 = function (_mge_x, _mge_y, _mge_z) {
		return [_mge_x, _mge_y, _mge_z];
	}

	Self.GetVector4 = function (_mge_x, _mge_y, _mge_z, _mge_w) {
		return [_mge_x, _mge_y, _mge_z, _mge_w];
	}
	
	//** Colors
	Self.ByteToFloat3 = function (_mge_color) {
		_mge_color[0] = _mge_color[0] * ColorByteToFloat;
		_mge_color[1] = _mge_color[1] * ColorByteToFloat;
		_mge_color[2] = _mge_color[2] * ColorByteToFloat;
	}
	
	Self.ByteToFloat4 = function (_mge_color) {
		_mge_color[0] = _mge_color[0] * ColorByteToFloat;
		_mge_color[1] = _mge_color[1] * ColorByteToFloat;
		_mge_color[2] = _mge_color[2] * ColorByteToFloat;
		_mge_color[3] = _mge_color[3] * ColorByteToFloat;
	}
	
	Self.FloatToByte3 = function (_mge_color) {
		_mge_color[0] = _mge_color[0] / ColorByteToFloat;
		_mge_color[1] = _mge_color[1] / ColorByteToFloat;
		_mge_color[2] = _mge_color[2] / ColorByteToFloat;
	}
	
	Self.FloatToByte4 = function (_mge_color) {
		_mge_color[0] = _mge_color[0] / ColorByteToFloat;
		_mge_color[1] = _mge_color[1] / ColorByteToFloat;
		_mge_color[2] = _mge_color[2] / ColorByteToFloat;
		_mge_color[3] = _mge_color[3] / ColorByteToFloat;
	}
	
	//** Convert
	Self.Min2 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = Self.Min(_mge_vec1[0], _mge_vec2[0]);
		_mge_vec1[1] = Self.Min(_mge_vec1[1], _mge_vec2[1]);
	}
	
	Self.Max2 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = Self.Max(_mge_vec1[0], _mge_vec2[0]);
		_mge_vec1[1] = Self.Max(_mge_vec1[1], _mge_vec2[1]);
	}
	
	Self.Min3 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = Self.Min(_mge_vec1[0], _mge_vec2[0]);
		_mge_vec1[1] = Self.Min(_mge_vec1[1], _mge_vec2[1]);
		_mge_vec1[2] = Self.Min(_mge_vec1[2], _mge_vec2[2]);
	}
	
	Self.Max3 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = Self.Max(_mge_vec1[0], _mge_vec2[0]);
		_mge_vec1[1] = Self.Max(_mge_vec1[1], _mge_vec2[1]);
		_mge_vec1[2] = Self.Max(_mge_vec1[2], _mge_vec2[2]);
	}
	
	Self.Replace2 = function (_mge_vec1, _mge_vec2) {
		var _x = _mge_vec1[0];
		var _y = _mge_vec1[1];
		_mge_vec1[0] = _mge_vec2[0];
		_mge_vec1[1] = _mge_vec2[1];
		_mge_vec2[0] = _x;
		_mge_vec2[1] = _y;
	}
	
	Self.Replace3 = function (_mge_vec1, _mge_vec2) {
		var _x = _mge_vec1[0];
		var _y = _mge_vec1[1];
		var _z = _mge_vec1[2];
		_mge_vec1[0] = _mge_vec2[0];
		_mge_vec1[1] = _mge_vec2[1];
		_mge_vec1[2] = _mge_vec2[2];
		_mge_vec2[0] = _x;
		_mge_vec2[1] = _y;
		_mge_vec2[2] = _z;
	}
	
	Self.Replace4 = function (_mge_vec1, _mge_vec2) {
		var _x = _mge_vec1[0];
		var _y = _mge_vec1[1];
		var _z = _mge_vec1[2];
		var _2 = _mge_vec1[3];
		_mge_vec1[0] = _mge_vec2[0];
		_mge_vec1[1] = _mge_vec2[1];
		_mge_vec1[2] = _mge_vec2[2];
		_mge_vec1[3] = _mge_vec2[3];
		_mge_vec2[0] = _x;
		_mge_vec2[1] = _y;
		_mge_vec2[2] = _z;
		_mge_vec2[3] = _2;
	}
	
	Self.Round2 = function (_mge_vec) {
		_mge_vec[0] = Math.round(_mge_vec[0]);
		_mge_vec[1] = Math.round(_mge_vec[1]);
	}
	
	Self.Round3 = function (_mge_vec) {
		_mge_vec[0] = Math.round(_mge_vec[0]);
		_mge_vec[1] = Math.round(_mge_vec[1]);
		_mge_vec[2] = Math.round(_mge_vec[2]);
	}

	Self.Round4 = function (_mge_vec) {
		_mge_vec[0] = Math.round(_mge_vec[0]);
		_mge_vec[1] = Math.round(_mge_vec[1]);
		_mge_vec[2] = Math.round(_mge_vec[2]);
		_mge_vec[3] = Math.round(_mge_vec[3]);
	}
	
	Self.Duplicate2 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec2[0];
		_mge_vec1[1] = _mge_vec2[1];
	}
	
	Self.Duplicate3 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec2[0];
		_mge_vec1[1] = _mge_vec2[1];
		_mge_vec1[2] = _mge_vec2[2];
	}
	
	Self.Duplicate4 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec2[0];
		_mge_vec1[1] = _mge_vec2[1];
		_mge_vec1[2] = _mge_vec2[2];
		_mge_vec1[3] = _mge_vec2[3];
	}
	
	Self.GetString2 = function (_mge_vec1) {
		return _mge_vec1[0] + " : " + _mge_vec1[1];
	}
	
	Self.GetString3 = function (_mge_vec1) {
		return _mge_vec1[0] + " : " + _mge_vec1[1] + " : " + _mge_vec1[2];
	}
	
	Self.GetString4 = function (_mge_vec1) {
		return _mge_vec1[0] + " : " + _mge_vec1[1] + " : " + _mge_vec1[2] + " : " + _mge_vec1[3];
	}
	
	//** Vectors 2	1
	Self.Add21 = function (_mge_vec1, _mge_num) {
		_mge_vec1[0] = _mge_vec1[0] + _mge_num;
		_mge_vec1[1] = _mge_vec1[1] + _mge_num;
	}
	
	Self.Sub21 = function (_mge_vec1, _mge_num) {
		_mge_vec1[0] = _mge_vec1[0] - _mge_num;
		_mge_vec1[1] = _mge_vec1[1] - _mge_num;
	}
	
	Self.Mul21 = function (_mge_vec1, _mge_num) {
		_mge_vec1[0] = _mge_vec1[0] * _mge_num;
		_mge_vec1[1] = _mge_vec1[1] * _mge_num;
	}
	
	Self.Div21 = function (_mge_vec1, _mge_num) {
		_mge_vec1[0] = _mge_vec1[0] / _mge_num;
		_mge_vec1[1] = _mge_vec1[1] / _mge_num;
	}
	
	//** Vectors 2	2
	Self.Add22 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec1[0] + _mge_vec2[0];
		_mge_vec1[1] = _mge_vec1[1] + _mge_vec2[1];
	}
	
	Self.Sub22 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec1[0] - _mge_vec2[0];
		_mge_vec1[1] = _mge_vec1[1] - _mge_vec2[1];
	}
	
	Self.Mul22 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec1[0] * _mge_vec2[0];
		_mge_vec1[1] = _mge_vec1[1] * _mge_vec2[1];
	}
	
	Self.Div22 = function (_mge_vec1, _mge_vec2) {
		_mge_vec1[0] = _mge_vec1[0] / _mge_vec2[0];
		_mge_vec1[1] = _mge_vec1[1] / _mge_vec2[1];
	}
	
	//** Equal
	Self.Equal21 = function (_mge_vec1, _mge_num) {
		return ((_mge_vec1[0] == _mge_num) && (_mge_vec1[1] == _mge_num))
	}
	
	Self.Equal22 = function (_mge_vec1, _mge_vec2) {
		return ((_mge_vec1[0] == _mge_vec2[0]) && (_mge_vec1[1] == _mge_vec2[1]))
	}
	
}

Vec = new MGEVector();

//alert("vector");



















